#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
arbres2.py (11.102)
Le type abstrait "arbre binaire d'expression" sur les
opérateurs + - * /
"""

def arbre(r, ag, ad):
    '''Retourne un arbre (noeud) de racine r, de fils gauche ag et de fils
    droit ad, sous la forme d'une liste de longueur 3.'''
    return [r, ag, ad]

def est_feuille(a):
    '''Retourne True ssi l'arbre a est réduit à une feuille.'''
    return type(a) in {int, float, str}

def racine(a):
    '''Retourne la racine de l'arbre binaire a, et une erreur si
    a est une feuille.'''
    if est_feuille(a):
        raise ValueError('Pas de racine pour la feuille {}'.format(a))
    return a[0]

def fg(a):
    '''Retourne le sous-arbre (fils) gauche de l'arbre binaire a,
    ou une erreur si a est une feuille.'''
    if est_feuille(a):
        raise ValueError('Pas de fg pour la feuille {}'.format(a))
    return a[1]

def fd(a):
    '''Retourne le sous-arbre (fils) gauche de l'arbre binaire a,
    ou une erreur si a est une feuille.'''
    if est_feuille(a):
        raise ValueError('Pas de fd pour la feuille {}'.format(a))
    return a[2]

if __name__ == '__main__':
    print("# Arbres binaires d'expression sur + - * /")
    print()
    atest = arbre('+',arbre('*',2,'x'),'y')           # ou ('+',('*',2,'x'),'y')
    print('>>> atest\n-->',atest,'     # (2*x) + y')
    print('>>> racine(fg(atest))           # racine du fils gauche\n-->',
        repr(racine(fg(atest))))
    print('>>> ad = fd(atest)              # fils droit')
    ad = fd(atest)
    print('>>> ad\n-->',repr(ad))
    print('>>> est_feuille(ad)\n-->',est_feuille(ad))


