######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

# beads_b    -  Visualisation de la forme d'onde
# Exercice 11.137 b)

add_library('beads')
ac = AudioContext()
jaune = color(255,255,0)
noir = color(0,0,0)

def setup() :
    size(300,150)
    stroke(jaune) ; strokeWeight(2)       # couleur et epaisseur du trait
    wp = WavePlayer(ac, 440, Buffer.SINE)
    g = Gain(ac,1,0.3)   # volume max 0.5
    g.addInput(wp)
    ac.out.addInput(g)
    ac.start()
    print 'Buffer size :', ac.getBufferSize()     # le print de Python 2...

def draw():
    background(noir)
    # calcul et affichage d'un tampon
    (xp,yp) = (0,height/2)
    for x in range(width):
        # ramenons la taille du tampon a une largeur de width
        buffIndex = x * ac.getBufferSize() / width
        # et calculons la hauteur de l'echantillon en ce point
        # avec un axe Ox au milieu vertical de la fenetre.
        y = int((1+ac.out.getValue(0, buffIndex)) * height / 2)
        y = min(y, height)
        # modification du pixel (x,y) de la fenetre (rapide)
        set(x,y,jaune)   # ou line(xp,yp,x,y) ; (xp,yp) = (x,y)
    #noLoop()    # décommentez cette ligne pour une image fixe
    
def stop():
    ac.stop()

    
