######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

# beads_d    -  Combinaison de deux signaux : 2 * wp + n
# Exercice 11.137 d)

add_library('beads')
ac = AudioContext()
jaune = color(255,255,0)
noir = color(0,0,0)

def setup() :
    size(512, 200)
    stroke(jaune) ; strokeWeight(2)
    wp = WavePlayer(ac, 440, Buffer.SINE)
    s2 = Static(ac,2)
    wp1 = Mult(ac,wp,s2)    # wp1 = "2*wp"
    n = Noise(ac)
    s = Add(ac,wp1,n)       # s = "2*wp + n"
    g = Gain(ac,1,0.3)      # tout doux, les amplitudes s'ajoutent...
    g.addInput(s)
    ac.out.addInput(g)
    ac.start()

def draw():
    background(noir)
    # calcul et affichage d'un tampon
    (xp,yp) = (0,height/2)
    for x in range(width):
        # ramenons la taille du tampon a une largeur de width
        buffIndex = x * ac.getBufferSize() / width
        # et calculons la hauteur de l'echantillon en ce point
        # avec un axe Ox au milieu vertical de la fenetre.
        y = int((1+ac.out.getValue(0, buffIndex)) * height / 2)
        y = min(y, height)
        # modification du pixel (x,y) de la fenetre (rapide)
        set(x,y,jaune)      # ou line(xp,yp,x,y) ; (xp,yp) = (x,y)
    #noLoop()
    
def stop():
    ac.stop()

    
