######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

# beads_e    -  Controle d'un gain par une UGen de type Glide (glisseur)
# le glisseur étant lui-même contrôlé par l'abscisse de la souris.
# Exercice 11.137 e)

add_library('beads')
ac = AudioContext()
glide = Glide(ac,0,50)                     # Glide(ac,initval,glidetime)
jaune = color(255,255,0)
noir = color(0)                            # <==> color(0)

def setup():
    size(300, 200)
    stroke(jaune) ; strokeWeight(2)
    wp = WavePlayer(ac, 440, Buffer.SINE)  # onde sinusoidale à 440 Hz
    wp1 = Mult(ac,wp,Static(ac,2))         # 2 * wp
    g = Gain(ac,1,0.2)                     # gain fixe 0.1 sur wp1
    g.addInput(wp1)
    n = Noise(ac)
    gn = Gain(ac,1,glide)                  # gain sur n avec controle par glide
    gn.addInput(n)
    s = Add(ac,g,gn)
    ac.out.addInput(s)
    ac.start()

def draw():
    background(noir)
    glide.setValue(float(mouseX) / width)  # action de la souris sur le gain gn
    # calcul et affichage d'un tampon
    (xp,yp) = (0,height/2)
    for x in range(width):
        # ramenons la taille du tampon a une largeur de width
        buffIndex = x * ac.getBufferSize() / width
        # et calculons la hauteur de l'echantillon en ce point
        # avec un axe Ox au milieu vertical de la fenetre.
        y = int((1+ac.out.getValue(0, buffIndex)) * height / 2)
        y = min(y, height)
        # modification du pixel (x,y) de la fenetre (rapide)
        set(x,y,jaune)   # ou line(xp,yp,x,y) ; (xp,yp) = (x,y)
    #noLoop()    # décommentez cette ligne pour une image fixe
    
def stop():
    ac.stop()

    
