######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

# beads_f    -  Enveloppes et rampes.
# Exercice 11.137 f)

add_library('beads')
ac = AudioContext()
jaune = color(255,255,0)
noir = color(0,0,0)

def setup():
    size(300,200)
    stroke(jaune) ; strokeWeight(2)
    env = Envelope(ac,200)                  # demarrage a 200 Hz
    for i in range(5):
        env.addSegment(800,500)             # 500 ms
        env.addSegment(200,500)             # 500 ms
    env.addSegment(0,300)                   # extinction en 300 ms
    wp = WavePlayer(ac,env,Buffer.SINE)     # env en argument pour controler la frequence !
    g = Gain(ac,1,0.5)
    g.addInput(wp)
    ac.out.addInput(g)
    ac.start()

def draw():
    background(noir)
    # calcul et affichage d'un tampon
    (xp,yp) = (0,height/2)
    for x in range(width):
        # ramenons la taille du tampon a une largeur de width
        buffIndex = x * ac.getBufferSize() / width
        # et calculons la hauteur de l'echantillon en ce point
        # avec un axe Ox au milieu vertical de la fenetre.
        y = int((1+ac.out.getValue(0, buffIndex)) * height / 2)
        y = min(y, height)
        # modification du pixel (x,y) de la fenetre (rapide)
        set(x,y,jaune)   # ou line(xp,yp,x,y) ; (xp,yp) = (x,y)
    #noLoop()    # décommentez cette ligne pour une image fixe
    
def stop():
    ac.stop()

    
