######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

# beads_g    -  Modulation de frequence (FM), effet de vibrato.
# Exercice 11.137 g)

add_library('beads')
ac = AudioContext()
jaune = color(255,255,0)
noir = color(0,0,0)

def setup():
    size(600,200)
    stroke(jaune) ; strokeWeight(2)
    lfo = WavePlayer(ac,1,Buffer.SINE)     # le modulateur (LFO) à 1 Hz qui varie entre -1 et 1
    u1 = Mult(ac,lfo,Static(ac,200))       # varie entre -200 et 200
    u2 = Add(ac,u1,Static(ac,600))         # varie entre 400 et 800
    mod = WavePlayer(ac,u2,Buffer.SINE)    # porteuse de frequence fournie par l'UGen u2
    g = Gain(ac,1,0.3)                     # gain fixe
    g.addInput(mod)
    ac.out.addInput(g)
    ac.start()

def draw():
    background(noir)
    # calcul et affichage d'un tampon
    (xp,yp) = (0,height/2)
    for x in range(width):
        # ramenons la taille du tampon a une largeur de width
        buffIndex = x * ac.getBufferSize() / width
        # et calculons la hauteur de l'echantillon en ce point
        # avec un axe Ox au milieu vertical de la fenetre.
        y = int((1+ac.out.getValue(0, buffIndex)) * height / 2)
        y = min(y, height)
        # modification du pixel (x,y) de la fenetre (rapide)
        set(x,y,jaune)   # ou line(xp,yp,x,y) ; (xp,yp) = (x,y)
    
def stop():
    ac.stop()

    
