######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

# beads_h    -  Modulation d'amplitude (AM), effet de tremolo.
# Exercice 11.137 h)

add_library('beads')
ac = AudioContext()
jaune = color(255,255,0)
noir = color(0,0,0)

def setup():
    size(300,200)
    stroke(jaune) ; strokeWeight(2)
    mod = WavePlayer(ac,0.5,Buffer.SINE)       # signal modulateur variant entre -1 et 1
    u1 = Add(ac,mod,Static(ac,1))              # entre 0 et 2
    lfo = Mult(ac,u1,Static(ac,0.5))           # LFO entre 0 et 1
    mod = WavePlayer(ac,440,Buffer.SINE)       # la porteuse a 440 Hz
    wp = Mult(ac,mod,lfo)                      # modulateur * porteuse
    g = Gain(ac,1,0.5)
    g.addInput(wp)
    ac.out.addInput(g)
    ac.start()

def draw():
    background(noir)
    # calcul et affichage d'un tampon
    (xp,yp) = (0,height/2)
    for x in range(width):
        # ramenons la taille du tampon a une largeur de width
        buffIndex = x * ac.getBufferSize() / width
        # et calculons la hauteur de l'echantillon en ce point
        # avec un axe Ox au milieu vertical de la fenetre.
        y = int((1+ac.out.getValue(0, buffIndex)) * height / 2)
        y = min(y, height)
        # modification du pixel (x,y) de la fenetre (rapide)
        set(x,y,jaune)   # ou line(xp,yp,x,y) ; (xp,yp) = (x,y)
  
def stop():
    ac.stop()

    
