######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

# beads_i  -  Le signal en dents de scie (sawtooth wave)
# Exercice 11.137 i)

add_library('beads')
ac = AudioContext()
jaune = color(255,255,0)
noir = color(0,0,0)

def setup():
    size(400,300)
    stroke(jaune) ; strokeWeight(1)
    wps = WavePlayer(ac,440,Buffer.SAW)    # <---- en dents de scie, toutes les harmoniques de 440 Hz
    g = Gain(ac,1,0.3)
    g.addInput(wps)
    ac.out.addInput(g)
    ac.start()

def draw():
    background(noir)
    # calcul et affichage d'un tampon
    (xp,yp) = (0,height/2)
    for x in range(width):
        # ramenons la taille du tampon a une largeur de width
        buffIndex = x * ac.getBufferSize() / width
        # et calculons la hauteur de l'echantillon en ce point
        # avec un axe Ox au milieu vertical de la fenetre.
        y = int((1+ac.out.getValue(0, buffIndex)) * height / 2)
        y = min(y, height)
        # modification du pixel (x,y) de la fenetre (rapide)
        line(xp,yp,x,y) ; (xp,yp) = (x,y)    # ou set(x,y,jaune)
    #noLoop()            # <-- regardez l'image en dents de scie...
   
def stop():
    ac.stop()
