######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

# beads_j  -  Synthese approximative du signal en dents de scie (sawtooth wave)
# avec une superposition de sinus sur les harmoniques.
# Le poids de chaque harmonique resulte des formules de Fourier (Wikipedia)...
# Pour un signal carre (Buffer.SQUARE), on ne prendrait que les harmoniques impaires !
# Exercice 11.137 j)

# ---> https://www.youtube.com/watch?v=ZRZIz81nXo4
# ---> https://www.coursera.org/learn/audio-signal-processing

add_library('beads')
ac = AudioContext()
jaune = color(255,255,0)
noir = color(0,0,0)

def setup():
    size(400,300)
    stroke(jaune) ; strokeWeight(1)
    wpc = WavePlayer(ac,440,Buffer.SINE)         # la fondamentale
    for k in range(2,10):                         # on ne prend que 8 harmoniques
        wpck = WavePlayer(ac,440*k,Buffer.SINE)  # l'harmonique numero k >= 2
        wpck = Mult(ac,wpck,Static(ac,1.0/k))    # avec des energies decroissantes
        wpc = Add(ac,wpc,wpck)                   # sommation
    wpc = Mult(ac,wpc,Static(ac,-1))             # pour des dents de scie inversees
    g = Gain(ac,1,0.2)
    g.addInput(wpc)
    ac.out.addInput(g)
    ac.start()

def draw():
    background(noir)
    # calcul et affichage d'un tampon
    (xp,yp) = (0,height/2)
    for x in range(width):
        # ramenons la taille du tampon a une largeur de width
        buffIndex = x * ac.getBufferSize() / width
        # et calculons la hauteur de l'echantillon en ce point
        # avec un axe Ox au milieu vertical de la fenetre.
        y = int((1+ac.out.getValue(0, buffIndex)) * height / 2)
        y = min(y, height)
        # modification du pixel (x,y) de la fenetre (rapide)
        line(xp,yp,x,y) ; (xp,yp) = (x,y)    # ou set(x,y,jaune)
    #noLoop()            # <-- regardez l'image "presque" en dents de scie...
              
def stop():
    ac.stop()
