######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

# beads_k    - Le lecteur SamplePlayer de fichier audio (.wav, .aif, .mp3)
# Essentiellement la Lesson04_SamplePlayer (menu Fichier/Exemples/Contrib Librairies in Python/Beads)
# Exercice 11.137 k)
 
add_library('beads')
ac = AudioContext()
jaune = color(255,255,0)
noir = color(0,0,0)
player = None
        
def setup():
    size(400, 300)
    stroke(jaune) ; strokeWeight(2)
    # La classe SamplePlayer permet de jouer un morceau sur disque. La vitesse et
    # la lecture en boucle peuvent être controlees par des UGens. Le point de depart
    # de la lecture dans le morceau peut aussi etre directement controle par une
    # UGen pour se deplacer rapidement dans un morceau (scrubbing).
    # https://en.wikipedia.org/wiki/Scrubbing_(audio)
    #
    #player = SamplePlayer(ac,Sample('/Users/roy/tmp/dylan.wav'))         # directement
    ac.start()
    if player:
        lancer(player)
    else:
        selectInput('Choisissez un morceau MP3, WAV ou AIFF','lecture')  # ou avec la souris
    # NB. La doc de Processing dit que le callback 'lecture' 
    # dans selectInput est obligatoire...
    
def lecture(fichier):          # fichier est le resultat de selectInput
    global player
    nom_fichier = fichier.getAbsolutePath()
    print('Ouverture du fichier : ' + nom_fichier)    # par ex. "dylan.wav" dans le dossier beads_k
    sample = SampleManager.sample(nom_fichier)        # un "morceau"
    player = SamplePlayer(ac,sample)                  # le joueur de ce morceau
    lancer(player)
    
def lancer(player):            # for your ears only
    g = Gain(ac,2,0.8)         # ou bien controlez le volume a la souris...
    g.addInput(player)
    ac.out.addInput(g)

def draw():
    background(noir)
    # calcul et affichage d'un tampon
    (xp,yp) = (0,height/2)
    for x in range(width):
        # ramenons la taille du tampon a une largeur de width
        buffIndex = x * ac.getBufferSize() / width        
        # et calculons la hauteur de l'echantillon en ce point
        # avec un axe Ox au milieu vertical de la fenetre.
        y = int((1+ac.out.getValue(0, buffIndex)) * height / 2)
        y = min(y, height)
        # modification du pixel (x,y) de la fenetre (rapide)
        line(xp,yp,x,y) ; (xp,yp) = (x,y)    # ou set(x,y,jaune)

def stop():
    println('Stop')
    ac.stop()
