######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

# beads_m
# Voir plus bas le code Java original qui a ete traduit en Python !
# Exercice 11.137 m)

add_library('beads')
ac = AudioContext()
jaune = color(255,255,0)
noir = color(0,0,0)

# Evan Merz utilise souvent une technique de classe anonyme en Java, qu'il
# faut traduire en sous-classe usuelle en Python.
class Freq_Control(Function):         # une sous-classe (non anonyme !) de Function
    def __init__(self,*ugens):        # mais une seule UGen pour nous plus bas, le modulateur
        Function.__init__(self,*ugens)  # <==> super(Freq_Control,self).__init__(*ugens)
    
    def calculate(self):              # ma fonction qui transforme les sorties des ugens
        return self.x[0] * 100 + 600  # x[i] est l'echantillon recu de l'ugen numero i parmi les ugens...

def setup():
    size(700, 300)
    stroke(jaune) ; strokeWeight(1)
    modulateur = WavePlayer(ac,2,Buffer.SINE)
    porteuse = WavePlayer(ac,Freq_Control(modulateur),Buffer.SINE)   # comparez avec la question g)
    g = Gain(ac,1,0.2)
    g.addInput(porteuse)
    ac.out.addInput(g)
    ac.start()

def draw():
    background(noir)
    # calcul et affichage d'un tampon
    (xp,yp) = (0,height/2)
    for x in range(width):
        # ramenons la taille du tampon a une largeur de width
        buffIndex = x * ac.getBufferSize() / width
        # et calculons la hauteur de l'echantillon en ce point
        # avec un axe Ox au milieu vertical de la fenetre.
        y = int((1+ac.out.getValue(0, buffIndex)) * height / 2)
        y = min(y, height)
        # modification du pixel (x,y) de la fenetre (rapide)
        # modification du pixel (x,y) de la fenetre (rapide)
        set(x,y,jaune)   # ou line(xp,yp,x,y) ; (xp,yp) = (x,y)

def stop() :
    ac.stop()
    
##################### Lesson03_FMSynthesis ########################################
# Menu "Fichier/Exemples/Contributed Librairies/Beads/Lesson03_FMSynthesis"
# en mode Java, dont les commentaires sont de la forme /* ...... */
#
# import beads.*;
# import java.util.Arrays; 

# AudioContext ac = new AudioContext();
# size(300, 300);
# /*
#  * In the last example Lesson02, we used an Envelope to
#  * control the frequency of a WavePlayer.
#  * In this example, we'll use another WavePlayer.
#  * This is called FM synthesis.
#  * Here's the modulating WavePlayer. It has a low frequency.
#  */
# WavePlayer freqModulator = new WavePlayer(ac, 2, Buffer.SINE);    /* le modulateur (LFO) */
# /*
#  * The next line might look outrageous if you're not
#  * experienced in Java. Basically we're defining a 
#  * Function on the fly which takes the freqModulator          /* on the fly : anonyme ! */
#  * and maps it to a sensible range. Since the input
#  * to the function is a sine wave (freqModulator), the
#  * output will be a sine wave that goes from 500 to 700,
#  * 50 times a second.
#  */
# Function function = new Function(freqModulator) {             /* Sous-classe anonyme en Python */
#    public float calculate() {
#       return x[0] * 100.0 + 600.0;                            /* x déclaré dans Function.java */
#    }
# };
# /*
#  * Here's the WavePlayer that will actually play.
#  * Now we plug in the function for the frequency. Compare this to
#  * the previous example, where we plugged in an envelope.
#  */
# WavePlayer wp = new WavePlayer(ac, function, Buffer.SINE);     /* la porteuse dont la fréquence */
# /*                                                             /* est controlée par la function */
#  * Connect it all together as usual.
#  */
# Gain g = new Gain(ac, 1, 0.2);
# g.addInput(wp);
# ac.out.addInput(g);
# ac.start();
