#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
code_trace.py - se forger un outil de TRACE pour espionner les fonctions récursives.
Code en page 43 du livre PAA. Ce module est importable.
"""

def trace(f):
    m = 0                          # longueur de la marge courante
    def f_trace(*args) :
        nonlocal m
        marge = m * '  '
        print('{} > {}{}'.format(marge, f.__name__, args))
        m = m + 1
        res = f(*args)             # appel récursif à f_trace !
        m = m - 1
        print('{} < {}'.format(marge, res))
        return res
    return f_trace

if __name__ == '__main__':
    def fac(n):               # factorielle
        if n == 0: return 1
        return n * fac(n-1)

    fac = trace(fac)          # maintenant fac est tracée
    res = fac(5)              # observez la trace !
    print('5! =',res,'    (coût linéaire)')

    print('-----------------------------')

    def fib(n):               # nombres de Fibonacci
        if n < 2: return n
        return fib(n-1) + fib(n-2)

    fib = trace(fib)
    res = fib(8)              # vous voyez pourquoi ce fib est lent ?
    # il passe son temps à refaire les mêmes calculs...
    print('fib(5) =',res,'     (coût exponentiel)')     




