#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_all.py (11.70)
Simulation des primitives 'all' (pour tout...) et 'any' (il existe...).
"""

def tous(pred,coll):
    '''Vérifie que tous les éléments de la collection L vérifient le
    prédicat unaire pred.'''
    for x in coll:
        if not pred(x): return False
    return True

def existe(pred,L):
    '''Vérifie s'il existe au moins un élément de L vérifiant le
    prédicat unaire pred.'''
    return not tous(lambda x: not pred(x),L)

if __name__ == '__main__':
    print('>>> tous(lambda x: x%2 == 0),[2,7,4,6,0])\n-->',
         tous(lambda x: x%2 == 0,[2,7,4,6,0]))
    print('>>> tous(lambda x: x%2 == 0),[2,14,4,6,0])\n-->',
         tous(lambda x: x%2 == 0,[2,14,4,6,0]))
    print()
    print('>>> existe(lambda x: x%2 == 1),[2,7,4,6,0])\n-->',
         existe(lambda x: x%2 == 1,[2,7,4,6,0]))
    print('>>> existe(lambda x: x%2 == 1),[2,14,4,6,0])\n-->',
         existe(lambda x: x%2 == 1,[2,14,4,6,0]))
    print()
    print('Test du vrai "all" de Python :')
    print('>>> all(map(lambda x: x%2 == 0,[2,7,4,6,0]))\n-->',
          all(map(lambda x: x%2 == 0,[2,7,4,6,0])))
    print('Test du vrai "any" de Python :')
    print('>>> any(map(lambda x: x%2 == 1,[2,7,4,6,0]))\n-->',
          any(map(lambda x: x%2 == 1,[2,7,4,6,0])))
    print('# Rappel : map retourne un ITERATEUR et non une collection !')
          
    
    
