#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_apple.py (11.124)
Script pour tester la crontab en Python.
Chargement dans un fichier "AAPL.txt" du cours en temps réel de l'action Apple sur le Nasdaq.
"""

import requests

MY_API_KEY = "?????????????"    # pour Alpha Vantage, demandez une clé !
# mieux vaut demander poliment une clé gratuite, sinon gare à votre adresse IP :-)

url = 'https://www.alphavantage.co/query?apikey={}&function={}&symbol={}'
url = url.format(MY_API_KEY,'GLOBAL_QUOTE','AAPL')   # le dernier cours disponible
print("Connexion à Alpha Vantage pour le cours actuel de l'action APPLE")
reponse = requests.get(url)
contenu = reponse.json()
# contenu est un dictionnaire à une seule entrée de la forme :
# {'Global Quote':
#   {'01. symbol': 'AAPL',
#    '02. open': '174.2800',
#    '03. high': '174.6262',
#    '04. low': '172.8900',
#    '05. price': '174.5400',
#    '06. volume': '14053105',
#    '07. latest trading day': '2019-03-01',
#    '08. previous close': '173.1500',
#    '09. change': '1.3900',
#    '10. change percent': '0.8028%'}}
data = contenu['Global Quote']
cours = data['05. price']
date = data['07. latest trading day']
# On ouvre le fichier AAPL.txt et on ajoute ce cours de clôture à la fin :
with open('/Users/roy/scripts/AAPL.txt','w') as f_out:
    f_out.write('{};{}\n'.format(date,cours))

from webbrowser import open as browse
browse('https://www.alphavantage.co')
