#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_apple_crontab.py (11.124)
Programmation de la surveillance d'un cours de bourse,
avec crontab en Python.
"""

from crontab import CronTab

# mettez à jour votre nom d'utilisateur 'xxxx' dans le code ci-dessous !
ma_crontab = CronTab(user='xxxx')   # accès à MA crontab sur mon poste de travail

# Ajout d'un nouveau job à ma crontab (adaptez suivant votre O.S., ci-dessous Unix)
cmd = '/Users/xxxx/anaconda3/bin/python3 /Users/xxxx/scripts/exo_apple.py'
job = ma_crontab.new(command=cmd)   # un nouveau job
job.comment= 'apple'                # pour le retrouver plus tard...

# A quels moments dois-je exécuter ce job ?
# Chaque samedi à 7h00 :
# 00  07  *  *  6  /Users/xxxx/anaconda3/bin/python3  /Users/xxxx/scripts/exo_apple.py
#                  ------- exécutable Python -------  -------- script ----------------

#job.dow.on(6)       # DayOfWeek : le samedi (jour numéro 6)
#job.hour.on(7)      # à 7h
#job.minute.on(0)    # et 0mn
job.dow.on(4)       # DayOfWeek : le samedi (jour numéro 6)
job.hour.on(16)      # à 7h
job.minute.on(31)    # et 0mn

##    *     *     *   *    *    <commande à exécuter>
##    -     -     -   -    -
##    |     |     |   |    |
##    |     |     |   |    +----- jour de la semaine (0 - 6) (dimanche=0)
##    |     |     |   +------- mois (1 - 12)
##    |     |     +--------- jour du mois (1 - 31)
##    |     +----------- heure (0 - 23)
##    +------------- minute (0 - 59)

ma_crontab.write()   # Ajouter ce job à ma crontab (important !)

# Voir éventuellement la crontab courante pour vérifier :

print('Etat de la crontab :\n',ma_crontab)
# 00  07  *  *  6  /Users/moi/anaconda3/bin/python3  /Users/moi/scripts/exo_apple.py


# Voir les jobs dont le commentaire contient 'apple' :
# print(list(ma_crontab.find_comment('apple')))

# Supprimer toute ma crontab avec ma_crontab.remove_all(), suivi de .write() !

# Rechercher des jobs avec .find_comment, .find_time, .find_command
# pour le cas échéant les supprimer, etc.

# Il est conseillé d'avoir un Terminal ouvert lorsque vous débutez avec
# crontab, pour vérifier l'effet de vos commandes avec 'crontab -l', etc.

# COMPLEMENTS EN LIGNE
from webbrowser import open as browse
#browse('https://fr.wikipedia.org/wiki/Cron')
#browse('https://pypi.python.org/pypi/python-crontab')
#browse('https://creativpi.fr/astuce-19-envoyer-sms-python-lapi-freesms/')



