#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_arbreit.py (11.105)
Parcours en profondeur itératif d'un arbre binaire, avec pile
"""

from exo_pile import *
from exo_arbrebin import *

def nb_feuilles_iter(a,trace=False):
    '''Retourne le nombre de feuilles de l'arbre binaire a, par un
    parcours en profondeur itératif.'''
    pile = pile_vide()
    res = 0                     # le résultat
    while True:                 # tant que la pile n'est pas vide
        if trace: print('a = {}, res = {}, pile = {}'.format(a,res,pile))
        if est_feuille(a):
            if est_pile_vide(pile): return res + 1       # FINI
            res += 1
            a = depiler(pile)
        else :
            empiler(fd(a),pile)
            a = fg(a)

def postfixe(a):                # pour rappel, le parcours postfixe récursif
    if est_feuille(a): return [a]
    return postfixe(fg(a)) + postfixe(fd(a)) + [racine(a)]

def post_arbre(L,trace=False):  # ...et sa bijection réciproque, en itératif.
    '''Retourne l'arbre binaire dont le parcours postfixe est la liste plate L.'''
    pile = pile_vide()
    i = 0                       # indice courant sur la liste L, de gauche à droite
    while True:
        if trace: print('L={}, i={}, pile={}'.format(L[i:],i,pile))
        if i >= len(L) : return sommet(pile)
        if L[i] not in OPS :    # le dictionnaire OPS est importée par exo_arbrebin
            empiler(L[i],pile)
        else:                   # je suis sur un opérateur, je construis un noeud
            a2 = depiler(pile)   # dont les deux fils sont en haut de la pile
            a1 = depiler(pile)
            empiler(arbre(L[i],a1,a2),pile)
        i += 1

if __name__ == '__main__':
    print("Parcours itératif d'un arbre avec pile explicite.")
    print()
    atest = ['-', ['*', 2, ['+','x',1]], ['/','x','y']]
    print('>>> atest\n-->',atest)
    print()
    print('# Nombre de feuilles en itératif :')
    print('>>> nb_feuilles_iter(atest,trace=True)    # itératif')
    n = nb_feuilles_iter(atest,trace=True)
    print('-->',n)
    print()
    print('# Parcours postfixe plat L de atest :')
    print('>>> atest\n-->',atest)
    print('>>> L = postfixe(atest)')
    L = postfixe(atest)
    print('>>> L\n-->',L)
    print()
    print("# Reconstruction itérative de l'arbre a à partir de L :")
    print('>>> a = post_arbre(L,trace=True)')
    a = post_arbre(L,trace=True)
    print('-->',a)
    if a != atest :
        raise ValueError('Bug dans post_arbre')
    else:
        print('Ok')




