#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_champ.py (11.44)
Les approximations du nombre de Champernowne
"""

from sys import setrecursionlimit   # l'anti-bombe...
# NB. Dans ma version de Spyder, il semble que setrecursionlimit
# est conservé d'un essai au suivant, même avec une console neuve (bug ?). Donc
# pour l'heure je force recursionlimit à 2000 pour avoir le 'Oups' plus bas.
setrecursionlimit(2000)

# ----- Récurrence -----

def champ_rec(n):           # a) on suppose n entier > 0, récurrence sur n
    if n == 1: return '0.1'
    return champ_rec(n-1) + str(n)

print('champ_rec(15) =',champ_rec(15))
print()
print("J'essaye de calculer champ_rec(2021) par récurrence...")
try:                        # oups, peut-être recursionlimit ?
    print('champ_rec(2021) contient',len(champ_rec(2021))-2,'décimales')
except:
    reclimit = True
    print("Oups, recursionlimit, j'augmente la pile à 3000.")
    import sys
    sys.setrecursionlimit(3000)    # hum...
    print('Ok : champ_rec(2021) contient',len(champ_rec(2021))-2,'décimales')
print()

# ----- Itération -----
    
def champ_iter(n):                # b) idem, itératif
    res = '0.1'
    for i in range(2,n+1):
        res = res + str(i)
    return res

print('champ_(iter15) =',champ_iter(15))
print('champ_iter(2021) contient',len(champ_iter(2021))-2,'décimales')

# Pour permettre à la récurrence de fonctionner :-(


# COMPLEMENTS EN LIGNE
from webbrowser import open as browse
#browse('https://fr.wikipedia.org/wiki/Nombre_univers')
#browse('https://fr.wikipedia.org/wiki/Constante_de_Champernowne')
