#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_chrono.py (11.75)
Pour le temps de calcul de f sur une liste à n et 2n éléments.
Permet de "sentir" l'évolution du temps de calcul...
"""

from random import randint
from time import time

def test_chrono(f,n,triee=False) :
    '''Test du temps de calcul de f : list -> ? pour deux listes de n
    et 2n elements. Passer triee=True pour tester sur des listes triees'''
    def temps(n) :
        L = [randint(0,n) for i in range(n)]
        if triee : L.sort()
        start = time() ; f(L) ; end = time()    # on jette le résultat...
        return end - start
    return (temps(n), temps(2*n))

if __name__ == '__main__' :
    from exo_trisel import tri_sel
    print('Les temps sont exprimés en secondes...')
    print()
    print('Notre tri par sélection pour 3000 et 6000 éléments :')
    print(test_chrono(tri_sel,3000))            # O(n**2)...
    print()
    from exo_triins import trier_ins_v3
    print('Notre tri par insertion pour 3000 et 6000 éléments :')
    print(test_chrono(trier_ins_v3,3000))         # O(n log n)...
    print()
    from exo_trifus import tri_fusion
    print('Notre tri par fusion pour 3000 et 6000 éléments :')
    print(test_chrono(tri_fusion,3000))         # O(n log n)...
    print()
    print('Le tri prédéfini .sort de Python pour 3000 et 6000 éléments :')
    print(test_chrono(lambda L : L.sort(),3000))            # O(n log n) FAST !
    print()
    print('Le tri prédéfini .sort de Python pour 100_000 et 200_000 éléments :')
    print(test_chrono(lambda L : L.sort(),100_000))         # O(n log n) FAST !



