#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_compact.py (11.67)
Compactage des éléments répétés consécutivement dans une liste.
"""

# La fonction compacter peut :
# - soit construire une copie transformée de L et la retourner en résultat
# - soit faire muter L, mais alors sans résultat

# a) Construction d'une copie transformée de L

def compacter(L):               # retourne une nouvelle liste
   if L == []: return L
   res = [L[0]]
   for i in range(1,len(L)):
       if L[i] != res[-1]:      # on compare au dernier élément mis dans res...
           res.append(L[i])
   return res

# b) Compactage sur place, avec mutation

def compacter_sur_place(L):     # sur place, en supprimant des éléments. Aucun résultat !
    i = 0
    while i < len(L):
        x = L[i]
        # supprimer les x qui suivent immediatement à droite
        j = i + 1
        while j < len(L) and L[j] == x:
            L.pop(j)             # hum :-(
        # se positionner sur le candidat suivant
        i = i + 1

if __name__ == '__main__':
    print('# Test de compacter sans mutation :')
    L = [3,3,3,8,5,5,5,7,7]
    print('>>> L\n-->',L)
    Lc = compacter(L)           # avec résultat, sans mutation
    print('>>> compacter(L)\n-->',Lc)
    print('>>> L              # intacte !\n-->',L)
    print()
    print('# Test de compacter_sur_place avec mutation :')
    print('>>> L\n-->',L)
    print('>>> id(L)          # adresse de L (en CPython)\n-->',id(L))
    compacter_sur_place(L)     # surtout pas de print !!!
    print('>>> compacter_sur_place(L)')
    print('>>> L\n-->',L)
    print('>>> id(L)          # L reste à la même adresse\n-->',id(L))

    # N.B. L'instruction L.pop(j) est-elle efficace ? Pas vraiment, car Python est
    # obligé de "boucher le trou" et de décaler vers la gauche tous les éléments à
    # droite de l'indice j. Donc à éviter si possible. Terrible si j est petit...

    # Testez ces exemples avec le Python Tutor !
    from webbrowser import open as browse
    #browse('http://pythontutor.com/visualize.html#mode=edit')















