#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_count.py (11.64)
Comptage d'éléments dans une collection. La méthode count.
"""

def compter_v1(pred,coll):         # un autre one-liner
    '''Retourne le nombre d'elements de la collection coll verifiant
    le predicat pred'''
    return sum(1 for x in coll if pred(x))

def compter_v2(pred,coll):         # one-liner
    '''Retourne le nombre d'elements de la collection coll verifiant
    le predicat pred'''
    return len(tuple(filter(pred,coll)))    # filter : cf exo 11.65

def compter_v3(pred,coll):         # itération classique
    res = 0
    for x in coll:
        if pred(x): 
            res += 1
    return res

if __name__ == '__main__':
    s = 'amendement'    # une séquence, comme les chaînes, les listes et les tuples
    print('Exemple avec la méthode count :')
    print('Le mot',repr(s),'contient',s.count('e'),'fois la lettre "e"')
    print()
    print('compter_v1:',repr(s),'contient',compter_v1(lambda c : c in 'aeiouy',s),'voyelles')
    print('compter_v2:',repr(s),'contient',compter_v2(lambda c : c in 'aeiouy',s),'voyelles')
    print('compter_v3:',repr(s),'contient',compter_v3(lambda c : c in 'aeiouy',s),'voyelles')
    print()
    e = {3,5,2,8,4}   # est une collection mais pas une séquence
    print('compter_v1:',e,'contient',compter_v1(lambda x : x > 3,e),'éléments > 3')
    print('compter_v2:',e,'contient',compter_v2(lambda x : x > 3,e),'éléments > 3')
    print('compter_v3:',e,'contient',compter_v3(lambda x : x > 3,e),'éléments > 3')
    
    
    
    
    
    


    





      
