#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_cplxeq.py (11.14)
Ce script peut être exécuté au Terminal par la commande :
                 python3 exo_cplseq.py
Solutions dans les complexes de l'équation ax**2+bx+c = 0 à coefficients 
a,b,c flottants.
"""

from cmath import sqrt as csqrt   # la racine carrée dans les complexes

# lecture des données (on peut faire mieux avec des boucles et des exceptions)
print("Solutions d'une équation a*x**2 + b*x + c == 0 à coeff. réels")
#a = float(input('Entrez a non nul : '))
#if a == 0 : raise ValueError('Valeur de a rejetée')
#b = float(input('Entrez b : '))
#c = float(input('Entrez c : '))

# une meilleure manière de lire les 3 coefficients en une seule fois, en 
# imitant la boucle d'interaction au toplevel qui est "grosso modo" :
#     while True : print(eval(input('>>> ')))
(a,b,c) = eval(input('Entrez (a,b,c) avec a non nul : '))
if a == 0 : raise ValueError('Valeur de a rejetée')

# le programme
delta = b**2 - 4 * a * c          # le discriminant de l'équation
print('delta =',delta,end=' ')
if delta > 0 : print('> 0 : deux racines réelles distinctes')
elif delta == 0 : print('== 0 : deux racines réelles égales') # à la précision près...
else : print('< 0 : deux racines complexes conjuguées')
rac_delta = csqrt(delta)          # csqrt(-4) == 2j
r1 = (-b + rac_delta) / (2 * a)
r2 = (-b - rac_delta) / (2 * a)
if r1.imag == 0 : r1 = r1.real    # si z est complexe : z.real et z.imag avec
if r2.imag == 0 : r2 = r2.real    # z == z.real + z.imag*1j

# le test
print('Ce sont {} et {}'.format(r1,r2))

# COMPLEMENTS EN LIGNE
from webbrowser import open as browse
#browse('https://fr.wikipedia.org/wiki/Équation_du_second_degré')
