#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_drapeau.py (11.68)
L'algorithme du drapeau hollandais de Dijkstra.
"""

from random import randint

def random_drapeau(n):
    couleurs = ('W','B','R')                    # White, Blue, Red
    def random_couleur() :
        return couleurs[randint(0,2)]
    return [random_couleur() for i in range(n)] # ou avec un map...

def echanger(L,i,j,trace=False):
    '''Echange sur place L[i] et L[j]'''
    if i != j : (L[i],L[j]) = (L[j],L[i])       # L[i] est une variable indexée
    if trace: print("J'échange les éléments numéro",i,'et',j)

def verif(L,i,j,x):
    '''Vérifie que L[i:j] ne contient que des x. Pour l'invariant de boucle.'''
    return L[i:j] == (j-i)*[x]

def tri_drapeau(L,trace=False):          # avec mutation du drapeau L
    cpt = 0
    n = len(L)
    (i,j,k) = (0,0,n)
    if trace: print('L =',L)
    while k > j:
        # INVARIANT L[:i] == 'B', L[i:j] == 'W', L[j:k] == ?, L[k:] == 'R'
        #assert verif(L,0,i,'B') and verif(L,i,j,'W') and verif(L,k,n,'R')
        couleur = L[j]                   # la case mise en examen :-)
        if couleur == 'B':
            echanger(L,i,j,trace)
            cpt += 1
            i += 1
            j += 1
        elif couleur == 'W':
            j += 1
        else:
            echanger(L,j,k-1,trace)
            cpt += 1
            k -= 1
    assert cpt <= len(L)             # vérification du nombre d'échanges
    if trace:
        print('L =',L)
        print('en',cpt,'échanges')

if __name__ == '__main__':
    print('Un exemple au hasard avec trace :')
    L = random_drapeau(8)
    tri_drapeau(L,trace=True)
    print()
    print('Et 5 essais aléatoires sans trace :')
    for i in range(5) :
        L = random_drapeau(8)
        print('L =',L)
        tri_drapeau(L)
        print('tri :',L)
        print()

    from webbrowser import open as browse
    #browse('https://fr.wikipedia.org/wiki/Problème_du_drapeau_hollandais')

    # Illustrez graphiquement avec une tortue ou un GUI en tkinter !...




