#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_einstein.py (11.8)
Addition relativiste des vitesses
"""

c = 300000   # km/sec, vitesse de la lumière
c2 = c * c   # pour éviter les recalculs

def einstein(u,v) :
    '''Retourne la somme relativiste des vitesses u et v < 300000 km/s'''
    return (u + v) / (1 + u*v/c2)

# Formulation équivalente en Python lorsque la fonction est
# une simple formule :

einstein = lambda u,v : (u + v) / (1 + u*v/c2)

w = einstein(250000,290000)
print('250000 km/s + 290000 km/s =',w,'km/s')

# COMPLEMENT. Pour afficher 4 chiffres après le point décimal du
# nombre flottant x, on peut utiliser la notation {:.4f}.format(x)
# Voir la section §3.4 du livre consacrée aux "chaînes formatées"...

print('250000 km/s + 290000 km/s = {:.2f} km/s'.format(w))
print('250000 km/s + 290000 km/s = {:.0f} km/s'.format(w))

# COMPLEMENTS EN LIGNE
from webbrowser import open as browse
#browse('http://www.astrosurf.com/luxorion/relativite-restreinte-ex2.htm')
