#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_fich2.py (11.117)
Lecture d'un fichier texte
"""

def cat(f):     # la célèbre commande 'cat' du Terminal Unix
    '''Affiche au toplevel Python de contenu du fichier texte f.
    Analogue à la commande "cat" de Unix.'''
    print('==================={}========================='.format(f))
    f_in = open(f,'r')                      # encodage par défaut
    contenu = f_in.read()                   # autre solution : ligne à ligne...
    f_in.close()
    print(contenu)
    print('=======================================================')

def numerise(s):                            # '56' --> 56 et '56.71' --> 56.71
    try:
        return int(s)
    except:
        try:
            return float(s)
        except:
            raise ValueError('Ce fichier ne doit contenir que des int ou float !')

def bilan_fichier_nombres_v1(f):            # lecture ligne à ligne
    L_entiers = []
    nb_flottants = 0
    with open(f,'r') as f_in:
        for ligne in f_in:
            L = [numerise(x) for x in ligne.split()]
            L_entiers.extend([x for x in L if type(x) == int])
            nb_flottants += sum(1 for x in L if type(x) == float)
    print('[version 1] Le fichier contient {} entiers :\n{}'.format(len(L_entiers),L_entiers))
    print('et il y a',nb_flottants,'nombres flottants dans ce fichier.')

def bilan_fichier_nombres_v2(f):    # lecture d'un seul coup (fichier pas trop gros)
    L_entiers = []
    nb_flottants = 0
    with open(f,'r') as f_in:
        L = [numerise(x) for x in f_in.read().split()]
        L_entiers = [x for x in L if type(x) == int]
        nb_flottants = sum(1 for x in L if type(x) == float)
    print('[version 2] Le fichier contient {} entiers :\n{}'.format(len(L_entiers),L_entiers))
    print('et il y a',nb_flottants,'nombres flottants dans ce fichier.')

def definitions(f,mode='all'):
    with open(f,'r',encoding='utf-8') as f_in:
        for ligne in f_in :
            if ligne[:4] == 'def ':             # 'def' en tête ?
                print(ligne,end='')             # ne pas afficher deux fois '\n'
                if mode == 'first': break

if __name__ == '__main__':
    from exo_fich1 import fichier_nombres
    fichier_nombres('nombres.txt')              # construction du fichier de nombres
    cat('nombres.txt')                          # affiche ce fichier    print()
    bilan_fichier_nombres_v1('nombres.txt')     # et son bilan
    print()
    bilan_fichier_nombres_v2('nombres.txt')     # et son bilan
    print()
    print('Définitions au toplevel du fichier courant "exo_fich2.py" :')
    print('- La première seulement :')
    definitions('exo_fich2.py',mode='first')
    print('- Toutes :')
    definitions('exo_fich2.py')

    # COMPLEMENTS EN LIGNE
    from webbrowser import open as browse
    #browse('https://docs.python.org/3/tutorial/inputoutput.html#reading-and-writing-files')


