#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_html.py (11.49)
HTML et Unicode...
"""

def unicode_html(s):
    '''Prend une chaîne unicode s et retourne la même chaîne
    codée en HTML.'''
    # l'encodage en ascii fera une erreur sur les caractères non ascii
    # et passera la main à xmlcharrefreplace. Le résultat est une raw
    # string décodée en UTF-8 pour Python.
    return s.encode('ascii', 'xmlcharrefreplace').decode('utf-8')

from html import unescape as html_unicode    # html_unicode est définie !

if __name__ == '__main__':
    print('Avez-vous les polices de caractères du chinois simplifié GB ?')
    s1 = "&Agrave; l'&#233;l&#232;ve &#29579; !"     # HTML
    s2 = "À l'élève 王 !"                            # 王 se lit 'wang'
    # notez que '王' == '\u738b' en Unicode, et 0x738b == 29579
    print('HTML --> UNICODE :')
    print(repr(s1),'\n    -->',repr(html_unicode(s1)))
    print('"&pi;"\n    -->',html_unicode('&pi;'))
    print()
    print('UNICODE --> HTML :')
    print(repr(s2),'\n    -->',repr(unicode_html(s2)))
    
    # COMPLEMENTS EN LIGNE
    from webbrowser import open as browse
    #browse('http://ramou.net/iphp/hanzi.php?uni=29579')   # wang '王'
    #browse('https://fr.wikipedia.org/wiki/Codage_des_caractères_chinois')
    #browse('https://www.jchr.be/html/caracteres.htm')
    
