#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_impot.py (11.10)
Raisonner avec plusieurs cas
"""

def tranche(s,b,h,p):
    if s < b:
        return 0
    elif s <= h:
        return (s - b) * p / 100
    return (h - b) * p / 100         # <-- else est implicite

print('Tranche pour un salaire de 2500€ :',tranche(2500,2000,3000,10))
print('Tranche pour un salaire de 4000€ :',tranche(4000,2000,3000,10))
print()

def impot(s):
    return tranche(s,8000,25000,10) + tranche(s,25000,1000000000000000000000,20)   # laid !

print('Impôt pour un salaire de 40000 euros :',impot(40000))
print()

# 10000000000000000000000000 doit être remplacé par +infini qui s'écrit
# en Python float('inf') et suit les règles de calcul avec l'infini. Il
# s'affiche inf mais Python ne connaît pas la variable inf. Je l'introduis :

inf = float('inf')                    # +infini et donc -inf pour -infini
print('inf - 1000 -->',inf - 1000)    # inf
print('-2 * inf -->',-2 * inf)        # -inf
print('1/inf -->',1/inf)              # 0.0 positif
print('-1/inf -->',-1/inf)            # -0.0 négatif
# Certains calculs conduisent à une forme "indéterminée" en maths, notée nan
# en Python. Elle s'affiche nan mais Python ne connaît pas la variable nan :
nan = float('nan')
print('inf / inf -->',inf / inf)      # forme indéterminée nan
print('inf - inf -->',inf - inf)
print()

def impot(s):
    return tranche(s,8000,25000,10) + tranche(s,25000,inf,20)

print('Impôt pour un salaire de 40000 euros :',impot(40000))

