#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_integ3.py (11.32)
Centre de gravité d'une figure plane avec une densité
superficielle de matière.
"""

# En passant du discret au continu, les sommes deviennent des intégrales !

from exo_integ2 import integrale2_fubini as integrale
# integrale(f,a,b,c,d,nx,ny), où c,d sont des nombres ou des fonctions
from math import sqrt, pi

def gamma(x,y):
    return x*x + y*y   # la densité surfacique augmente avec la distance au centre

def centre_gravite(nx,ny):
    masse_totale = integrale(gamma,-1,1,0,lambda x: sqrt(1-x*x),nx,ny)
    print('masse_totale =',masse_totale)
    xG = integrale(lambda x,y: x*gamma(x,y),-1,1,0,lambda x: sqrt(1-x*x),nx,ny)
    yG = integrale(lambda x,y: y*gamma(x,y),-1,1,0,lambda x: sqrt(1-x*x),nx,ny)
    return (xG/masse_totale,yG/masse_totale)

print('Coordonnées approchées du centre de gravité :')
(xG,yG) = centre_gravite(100,100)
print('xG = {:.10f}, yG = {:.10f}'.format(xG,yG))
print()
print('Valeurs exactes (0,8/(5*pi) :',(0,8/(5*pi)))





