#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_lex1_student.py  (11.112) -- l'analyseur lexical du §7.2 à COMPLETER,
pour faire l'exercice du §11.112 du livre.
Illustration de SLY, logiciel Lex/Yacc pour Python de D. Beazley.
(SLY remplace l'ancienne version PLY du même auteur).
Analyseur lexical pour des expressions arithmétiques sur les
opérateurs + - * / ** avec des nombres entiers et flottants et
des variables. La solution est dans "exo_lex1.py".
"""

from sly import Lexer

class LexerError(Exception):    # juste pour la lisibilité des exceptions
    pass

# Rajoutez les types de tokens FLOAT, VAR et PUIS, ainsi que l'attribut vars.

class ArithLexer(Lexer):
    # l'ensemble des types de tokens (en premier !)
    tokens = {INT, ADD, SUB, MUL, DIV, PARG, PARD}
    # les différents types de tokens avec leur expression régulière
    INT = '[0-9]+'
    ADD = '[+]'          # ou '\+'
    SUB = '-'
    MUL = '[*]'          # ou '\*'
    DIV = '/'
    PARG = '[(]'         # ou '\('
    PARD = '[)]'         # ou '\)'
    # la chaîne contenant les caractères à ignorer : espace et tabulation
    ignore = ' \t'

    def INT(self, t):             # une action à la lecture d'un token t de type INT
        t.value = int(t.value)
        return t

    def error(self,t):            # je suis sur un caractère provoquant une erreur
        msg = 'sur "{}" en ligne {} colonne {}'.format(t.value[0],t.lineno,t.index)
        raise LexerError(msg)


if __name__ == '__main__':
    def test_lexer(s):           # une petite fonction de test
        print('Complétez ce fichier !')

    test_lexer('12.567*(35-3)**2')
    test_lexer('3.5h12L24-n8')
    test_lexer('18**n5+3.2')
    test_lexer('18**@+3.2')

    from webbrowser import open as browse
    #browse('https://docs.python.org/fr/3/library/re.html')      # les regexp...
    #browse('http://www.matthieuamiguet.ch/pages/compilateurs')  # pour PLY, peu importe
    #browse('https://www.youtube.com/watch?v=zJ9z6Ge-vXs')       # SLY @ PYCON 2018
    #browse('https://sly.readthedocs.io/en/latest/index.html')   # doc de SLY

