#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_magic.py (11.84)
Carrés magiques d'ordre impair avec l'algorithme siamois.
"""

from exo_mat1 import mat_repr 

def carre_magique(n):
    m = [n*[0] for i in range(n)]
    (i,j) = (0,n//2)
    pion = 1
    m[i][j] = pion              # posons le premier pion 1
    for k in range(n*n-1):      # et posons les autres
        # on gère d'abord tous les cas particuliers
        if i == 0:              # en première ligne ?
            if j == n-1:        # en dernière colonne ?
                i = i + 1
            else :                    
                (i,j) = (n-1,j+1)
        elif j == n - 1:        # en dernière colonne mais pas en première ligne
            (i,j) = (i-1,0)
        else:                   # en plein dedans
            (isuiv,jsuiv) = (i-1,j+1)   # on essaye de monter sur la diagonale à droite
            if m[isuiv][jsuiv] == 0 :   # est-ce libre ?
                (i,j) = (isuiv,jsuiv)
            else :
                i = i + 1
        pion = pion + 1
        m[i][j] = pion
    return m

# todo: introduire des % pour gérer la circularité des lignes, colonnes ?
    
if __name__ == '__main__':
    print("Construction d'un carré magique d'ordre impair." )
    while True:
        try:
            n = int(input('Donnez un nombre > 0 impair (0 pour quitter) : '))
        except:
            continue
        if n == 0: break
        if (n < 0 or n%2 == 0): continue
        print("Carré magique d'ordre {} :".format(n))
        sol = carre_magique(n)
        print(mat_repr(sol,prec=0))
        print()
    
    from webbrowser import open as browse
    #browse('https://fr.wikipedia.org/wiki/Carr%e9_magique_(math%e9matiques)')

        
    
    





      
