#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_mutat.py (11.71)
Attention aux MUTATIONS dans les listes : danger... !
"""

print('>>> L1 = [0, 2]')
L1 = [0,2]
print('>>> L2 = [L1, L1, L1 + L1]')
L2 = [L1,L1,L1 + L1]
print('>>> (L2[0] is L1) and (L2[1] is L1)\n-->', 
      (L2[0] is L1) and (L2[1] is L1))
# L2[0] et L2[1] sont la MEME liste L1 en mémoire ! Mais L1 + L1 est nouvelle.
print('>>> L1[0] = 10')
L1[0] = 10              # ce qui perturbe L2[0] et L2[1] en même temps !!! OUPS...
print('>>> L1\n-->',L1)
print('>>> L2\n-->',L2)
print()

# La fonction 'copy' de Python permet de cloner un objet (au premier niveau,
# utiliser 'deepcopy' pour un clonage en profondeur...).

from copy import copy

print('Avec copy :')
print('>>> L1 = [0, 2]')
L1 = [0,2]
print('>>> L2 = [copy(L1),copy(L1),L1 + L1])')
L2 = [copy(L1),copy(L1),L1 + L1]    # Les 3 listes sont nouvelles !
print('>>> L1\n-->',L1)
print('>>> L2\n-->',L2)
print('>>> L2[0] is L2[1]    # mais elles sont ==\n-->', L2[0] is L2[1])
print('>>> L1[0] = 10')
L1[0] = 10                          # ne touche plus L2...
print('>>> L1\n-->',L1)
print('>>> L2\n-->',L2)
print()

# TRES IMPORTANT A BIEN COMPRENDRE ! ON MANIPULE CE QUE LES
# PROGRAMMEURS C NOMMENT DES "POINTEURS" ET LES PROGRAMMEURS
# JAVA OU PYTHON DES "REFERENCES". DELICAT EN PRESENCE DE MUTATIONS !
# MORALE : EVITER LES MUTATIONS LORSQUE C'EST POSSIBLE.

# Et - si possible aussi - ne pas faire muter les arguments d'une fonction,
# seulement ses variables locales.
# Utiliser le "Python Tutor" pour voir visuellement l'état de la mémoire :
from webbrowser import open as browse
#browse('http://pythontutor.com/visualize.html#mode=edit')






      
