#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_palin.py (11.43)
Les palindromes.
Pour simplifier, on ne gère pas les caractères accentués !
"""

# Question a)

def est_palindrome_v1(m):   # m est un mot (chaîne sans espaces ni tabulation)
    return m == m[::-1]     # m[::-1] est l'inverse de m

# Bon, une solution classique quand même qui évite de recopier la chaîne en mémoire :

def est_palindrome_v2(m):       # itération
    i = 0 ; j = len(m)-1        # indices des extrémités, on resserre i--> <--j
    while i < j:
        # print('Je compare',m[i],'et',m[j])
        if m[i] != m[j]: return False
        (i,j) = (i+1,j-1)
    return True

# Question b)
    
def est_phrase_palindrome(s):       # la phrase s est-elle palindromique ?
    # suppression des espaces
    s = ''.join(list(filter(lambda c : c not in ' \t',s)))
    # print('s -->',s)
    # on passe tout en minuscules
    s = s.upper()
    #print('s -->',s)
    return est_palindrome_v1(s)

if __name__ == '__main__':
    print('Tests de palindrome_v1 :')
    print('"radar" est un palindrome ? ',est_palindrome_v1('radar'))
    print('"elle" est un palindrome ? ',est_palindrome_v1('radar'))
    print('"toto" est un palindrome ?  ',est_palindrome_v1('toto'))
    print('La chaîne vide est un palindrome ?',est_palindrome_v1(''))
    print()
    print('Tests de palindrome_v2 :')
    print('"radar" est un palindrome ? ',est_palindrome_v2('radar'))
    print('"elle" est un palindrome ? ',est_palindrome_v2('radar'))
    print('"toto" est un palindrome ?  ',est_palindrome_v2('toto'))
    print('La chaîne vide est un palindrome ?',est_palindrome_v2(''))
    print()
    print('Version 3')
    phrase = 'Esope reste ici     et se repose'
    if est_phrase_palindrome(phrase):
        print('Oui,',repr(phrase),'est une phrase palindromique.')
    else:
        print('Non,',repr(phrase),"n'est  pas une phrase palindromique.")

    from webbrowser import open as browse
    #browse('https://fr.wikipedia.org/wiki/Palindrome')
    #browse('http://villemin.gerard.free.fr/Langue/Palindro.htm')
