#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_pascal.py (11.72)
Le triangle de Pascal (coefficients du binôme de Newton).
"""

def ligne_suiv(L):     
    '''Retourne la ligne suivante de la ligne L du triangle de
    Pascal, sous forme de liste d'entiers.'''
    res = [1]
    for i in range(1,len(L)):
        res.append(L[i-1] + L[i])
    res.append(1)
    return res

def pascal(n):
    '''Retourne le triangle de Pascal jusqu'à la ligne n, sous
    la forme d'une liste de listes.'''
    res = [[1]]
    for i in range(n):
        res.append(ligne_suiv(res[-1]))
    return res

def affiche_pascal(P):
    '''Affiche le triangle de Pascal P "à la française".'''
    for L in P:
        for x in L:
            print('\t',x,end='')
        print()

def affiche_binome(n):
    '''Affiche le développement de (1+x)**n'''
    L = pascal(n)[-1]
    print('(1 + x)**{} == 1'.format(n),end=' ')
    if n == 0: print() ; return
    if n == 1: print('+ x') ; return
    print('+ {}x'.format(n),end=' ')
    for i in range(2,len(L)-1):
        print('+ {}x**{}'.format(L[i] if i>1 else '',i),end=' ')
    print('+ x**{}'.format(n))
    
if __name__ == '__main__':
    L = [1,3,3,1]
    print('ligne_suiv :',L,'-->',ligne_suiv(L))
    print()
    
    P5 = pascal(5)
    print('>>> pascal(5)\n-->',P5)
    print()
    
    print("Triangle de Pascal jusqu'à la ligne 5 :")
    affiche_pascal(P5)
    print()
    
    print('Une autre vision du triangle de Pascal :')
    for i in range(6):
        affiche_binome(i)
    
    from webbrowser import open as browse
    browse('http://villemin.gerard.free.fr/Wwwgvmm/Iteration/TrgPascF.htm')
    browse('https://fr.wikipedia.org/wiki/Formule_du_binôme_de_Newton')
    browse('https://fr.wikipedia.org/wiki/Triangle_de_Pascal')
    
    
    
    
