#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_pile.py (11.87)
Le type "pile de données", implémenté par des listes.
Toutes les opérations sont en O(1) amorti.
"""

def pile_vide():                      # empty stack
    '''Retourne une pile vide.'''
    return []

def est_pile_vide(p):
    '''Teste si une pile est vide.'''
    return p == []

def empiler(x,p):                     # push
    '''Ajoute l'élément x en sommet de pile.'''
    p.append(x)

def sommet(p):                        # top
    '''Retourne le sommet de pile sans le dépiler. Exception si
    la pile est vide.'''
    if p == []: raise ValueError('sommet : pile vide !')
    return p[-1]

def depiler(p):                       # pop
    '''Retourne le sommet de pile en le dépilant. Erreur si
    la pile est vide.'''
    if p == []: raise ValueError('depiler : pile vide !')
    return p.pop()

if __name__ == '__main__':
    p = pile_vide()
    print("# J'ai empilé 0,1,2,3,4 sur une pile vide p.")
    for i in range(5):
        empiler(i,p)
    print('>>> p\n-->',p)
    print('>>> sommet(p)\n-->',sommet(p))
    print('>>> pile\n-->',p)
    print('>>> depiler(p)        # avec effet sur p\n-->',depiler(p)) 
    print('>>> p\n-->',p)
    print('>>> empiler(10,p)')
    empiler(10,p)
    print('>>> p\n-->',p)
    print()
    
    # COMPLEMENTS EN LIGNE
    from webbrowser import open as browse
    #browse('https://fr.wikipedia.org/wiki/Pile_d%27exécution')
    #browse('https://fr.wikipedia.org/wiki/Pile_(informatique)')
    
    
    
