#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_plmot.py (11.39)
Liste des mots de longueur maximale dans une chaîne de caractères
"""

def plmots(s) :             # str --> list, s non vide
    '''Retourne la liste des mots de longueur maximale dans une chaine de caracteres.'''
    if s == '' : raise ValueError('plmots attend une chaîne non vide !')
    L = s.split()           # liste de tous les mots
    n = max(map(len,L))     # longueur maximum d'un mot de s
    print('L =',L,'et longueur max =',n,', solutions :')
    return list(filter(lambda m : len(m)==n,L))    # filter retourne un itérateur...

help(plmots)    # exécuté au Terminal, help est traduit en la commande Unix 'more'

print('Rappel sur la méthode .split sur une chaîne :')
print(">>> 'Je vous écrirai demain une missive'.split()")
print('Je vous écrirai demain une missive'.split())
print()

print(">>> plmots('Je vous écrirai demain une missive')")
print(plmots('Je vous écrirai demain\tune missive'))
print()

print(">>> plmots('')")
try:
    print(plmots(''))     # provoque une erreur que je vais attraper au vol...
except Exception as e:
    print('Oups, exception',repr(type(e).__name__))


    
