#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_prodcart.py (11.97)
Produit cartésien de deux ensembles (type 'set')
"""

def produit(e1,e2):                # à la main...
    '''Retourne l'ensemble produit des ensembles e1 et e2, soit
    l'ensemble des couples (x,y) avec x dans e1 et y dans e2.'''
    return {(x,y) for x in e1 for y in e2}

if __name__ == '__main__':
    e1 = {'a','b'}
    e2 = {1,2,3}
    print('>>> (e1, e2)\n-->',(e1, e2))
    print()
    print(">>> produit(e1,e2)     # {'a','b'} x {1,2,3}\n-->",
        produit(e1,e2))
    print()
    print('# Avec le module itertools, product retourne un')
    print('# itérateur sur des tuples :')
    from itertools import product
    it = product(e1,e2)
    print('>>> set(product(e1,e2))\n-->',set(product(e1,e2)))
    print()
    print(">>> set(product({'a','b'},{1,2},{3,4}))\n-->",
          set(product({'a','b'},{1,2},{3,4})))
    
    # COMPLEMENTS EN LIGNE 
    from webbrowser import open as browse
    #browse('https://fr.wikipedia.org/wiki/Opération_ensembliste')
    #browse('https://docs.python.org/fr/3/library/itertools.html')
    
    
    
