#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_puismod.py (11.22)
Calcul de x**k modulo n par dichotomie
"""

def puismod_rec(x,k,n):        # récursif
    if k == 0: return 1
    if k % 2 == 0: return ((puismod_rec(x,k // 2,n) % n) ** 2) % n
    return (x * puismod_rec(x,k-1,n)) % n

def puismod(x,k,n):            # itératif, voir exo_puisdicho.py
    (a,b,k) = (1,x,k)
    while k > 0:
        if k % 2 == 0: (a,b,k) = (a % n,b*b % n,k//2)
        else: (a,b,k) = (a*b % n,b*b % n,k//2)
    return a

if __name__ == '__main__':
    print('Test dans les petits entiers...')
    from random import randint
    x = randint(10**4,10**5)
    k = randint(10**4,10**5)
    n = randint(10**2,10**3)
    if not(puismod(x,k,n) == puismod_rec(x,k,n) == (x**k) % n):
        print('Bug avec (x,k,n) =',(x,k,n))
    print('Test dans les grands entiers...')
    x = randint(10**80,10**90)
    k = randint(10**80,10**90)
    n = randint(10**10,10**11)
    if puismod(x,k,n) != puismod_rec(x,k,n) : 
        print('Bug !')
    print('Ok. Assez rapide ?...')
    
    # COMPLEMENTS EN LIGNE
    from webbrowser import open as browse
    #browse('https://fr.wikipedia.org/wiki/Inverse_modulaire')
    