#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_pymunk_chute.py (11.130)
SOLUTION de la QUESTION 1 de l'exercice n° 130 du livre.
Deux balles de masses distinctes arrivent au sol en même temps (avec gravité
mais sans atmosphère de freinage).
"""

import pymunk
space = pymunk.Space()
space.gravity = (0,-1000)

m1 = 1    # balle de ping-pong (très légère)
body1 = pymunk.Body(m1,pymunk.inf)  # peu importe le moment...
space.add(body1)
body1.position = (100,600)

m2 = 200  # balle de golf (lourde)
body2 = pymunk.Body(m2,pymunk.inf)
space.add(body2)
body2.position = (200,600)

print()
print(' ping-pong (masse = 1)    golf (masse = 200)')
for i in range(30):
    print('{:10.1f}  {:24.1f}'.format(body1.position.y,body2.position.y))
    space.step(0.02)    # calcul de la position toutes les 0.02 unités de temps

# L'astronaute David Scott a été le premier à faire cette expérience sur la lune,
# dans le cadre de la mission Apollo 15, en lâchant en même temps un marteau et
# une plume, qui sont arrivés au sol, oui, vous avez deviné : EN MEME TEMPS !
# Vive la physique.

# COMPLEMENTS EN LIGNE
from webbrowser import open as browse
#browse('https://fr.wikipedia.org/wiki/Chute_libre_(physique)')   # important
#browse("https://fr.wikipedia.org/wiki/Principe_d'équivalence")   # plus spécialisé...
