#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_pymunk_essai.py (11.130)
Le plus petit programme en pymunk. On lance le MOTEUR DE CALCUL PHYSIQUE
sur un corps qui tombe dans le vide (donc peu importe sa masse !) et l'on
peut constater une accélération lors de la chute.
Aucun graphisme pour l'instant.
"""

import pymunk

space = pymunk.Space()
space.gravity = (0,-1000)
body = pymunk.Body(1,400)    # unités arbitraires, peu importent les valeurs
space.add(body)
body.position = (300,500)

def chop(vec2d):
    '''1 seule décimale pour chaque composante de vec2d'''
    return tuple(map(lambda c: float('{:.1f}'.format(c)),vec2d))

# les affichages montrent bien l'accélération
print()
print('body.position    body.velocity')
print('------------------------------')
for i in range(20):
    space.step(0.04)         # toutes les dt=0.04 unités de temps du moteur physique
    # affichage de la position et de la vitesse (deux Vec2D de pymunk)
    print(chop(body.position),'\t',chop(body.velocity))

print('space.gravity =',space.gravity)

# LA PAGE WEB DE PYMUNK
from webbrowser import open as browse
#browse('https://www.pymunk.org/en/latest/')