#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_quotient.py (11.2)
Quotient et reste dans la division euclidienne. Binaire.
"""

n = 2021
print('Soit n ==',n)

print('a)')
print('n // 10 ==',n // 10,', n % 10 ==',n % 10)
# donc n % 10 est le chiffre des unités et n // 10 l'entier privé
# du chiffre des unités.
print()

# idem en base 2, le binaire :
print('b)')
print("n s'écrit",bin(n),'en binaire.')
print('Une addition en binaire : 0b10 + 0b11 ==',bin(0b10 + 0b11))
print('n // 2 ==',bin(n // 2),'==',n // 2)
print('et n % 2 ==',n % 2,'   (n est impair !)')
print()

print('c)')
print('n est multiple de d <==> n % d == 0')
def est_multiple(n,d) :       # l'entier n >= 0 est-il un multiple de l'entier d >= 0 ?
    return n % d == 0         # le résultat est un booléen True ou False

print('23 est multiple de 8 -->',est_multiple(23,8))
print('24 est multiple de 8 -->',est_multiple(24,8))

def est_pair(n) :             # l'entier n est-il pair ?
    return n % 2 == 0

print('23 est pair -->',est_pair(23))
print('24 est pair -->',est_pair(24))
print()

print('d)')
# Conversion décimal --> binaire
# On évite d'utiliser des calculs de puissances, lents.
# Exemple avec n = 2021. On effectue une suite de divisions entières par 2.
# On stoppe dès que le quotient vaut 0. On remonte alors la suite des restes.
# 2021 // 2 = 1010            # le reste (dernier chiffre binaire de n) est 1
# 1010 // 2 = 505             # le reste est 0
# 505  // 2 = 252             # le reste est 1
# 252  // 2 = 126             # le reste est 0
# 126  // 2 = 63              # le reste est 0
# 63   // 2 = 31              # le reste est 1
# 31   // 2 = 15              # le reste est 1
# 15   // 2 = 7               # le reste est 1
# 7    // 2 = 3               # le reste est 1
# 3    // 2 = 1               # le reste est 1
# 1    // 2 = 0               # le reste est 1   STOP !
print("2021 décimal s'écrit 11111100101 en binaire. Vérification :")
print('2021 en binaire : ',bin(2021))
# N.B. Le nombre de fois que l'on peut diviser un entier n par 2 est d'ordre
# du logarithme (en base 2) de n. On dit que l'algorithme a un coût ou une
# complexité en O(log n) si l'on mesure le nombre de divisions.
print()

print('e)')
# Conversion binaire --> décimal
# La technique ci-dessous est la meilleure : le "schéma de Hörner".
# Technique : on parcours les chiffres binaires de gauche à droite. Le
#             résultat vaut 0 au départ. A chaque chiffre binaire, on
#             multiplie de résultat par 2 et on rajoute le chiffre binaire.
# 1101110 de gauche à droite, de tête :
# 0 -(1)-> 1 -(1)-> 3 -(0)-> 6 -(1)-> 13 -(1)-> 27 -(1)-> 55 -(0)-> 110
print("1101110 binaire s'écrit en décimal :",0b1101110)   # écriture directe en binaire

# Ces deux conversions seront programmées dans l'exercice: exo_addstrbin.py (11.47).

# COMPLEMENTS EN LIGNE
from webbrowser import open as browse
#browse('http://villemin.gerard.free.fr/Wwwgvmm/Numerati/BINAIRE/Introduc.htm')



