#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_rand1.py (11.12)
Entiers aléatoires et dés truqués
"""

# randint(a,b) pour tirer un entier au hasard dans [a,b]
from random import randint    

def rand_pair(n):
    '''Retourne un entier pair aléatoire de [0,n], n entier >= 0'''
    return 2 * randint(0, n // 2)

def rand_chiffres(n):
    ''' Retourne un entier aléatoire ayant exactement n chiffres'''
    # on bloque un nombre à n chiffres entre deux puissances de 10
    return randint(10**(n - 1),10**n - 1)

def monte_carlo() :    # dé équilibré
    '''Retourne 2,3 ou 5 au hasard'''
    hasard = randint(0,2)      # 0, 1 ou 2 au hasard, avec proba 1/3 chacun
    if hasard == 0 : return 2
    elif hasard == 1 : return 3   # elif ou if ici à cause du return précédent
    else : return 5               # else optionnel pour la même raison
# Une autre vision consisterait à bricoler une fonction qui envoie 0,1,2 sur 
# 2,3,5. Par exemple la parabole f(x) = a*x**2+b*x+c passant par les points 
# (0,2), (1,3) et (2,5). Un peu marteau-pilon... 

def las_vegas() :      # dé truqué
    '''Retourne 2 (proba=1/6), 3 (proba=1/3) ou 5 (proba=1/2)'''
    hasard = randint(0,5)         # un dé a 6 faces
    if hasard == 0 : return 2     # proba = 1/6
    if hasard <= 2 : return 3     # proba = 2/6 = 1/3
    return 5                      # proba = 3/6 = 1/2

# A partir de maintenant, vous verrez souvent ce "if __name__=='__main__':"
# qui permet de n'exécuter les tests que si ce module est exécuté pour
# lui-même et non importé par un autre module.
    
if __name__ == '__main__' :
    print('rand_pair(10) -->',rand_pair(10))
    print('rand_chiffres(5) -->',rand_chiffres(5))
    print('monte_carlo() --> ',monte_carlo())
    print('las_vegas() --> ',las_vegas())
    print()
    # ceci est une "compréhension de liste" (cf livre)
    print('Une suite de Las Vegas :')
    print([las_vegas() for i in range(30)])   

    # COMPLEMENTS EN LIGNE
    from webbrowser import open as browse
    #browse('https://fr.wikipedia.org/wiki/Générateur_de_nombres_pseudo-aléatoires')
    #browse('https://www.science-emergence.com/Articles/Générer-des-nombres-aléatoires-suivant-une-distribution-gaussienne-avec-python/')

