#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_ratio.py (11.13)
Les nombres rationnels. Qui sont-ils et à quoi ressemblent-ils ?
"""

# Pour le détail du calcul mathématique, voir le fichier : exo_ratio.pdf 

from fractions import Fraction

def rationalise(s1,s2,s3) :     # str x str x str --> Fraction
    # on suppose que seule s2 peut être vide ! s3 est le bloc périodique.
    n1 = int(s1) ; n2 = int(s2) if s2 != '' else 0 ; n3 = int(s3)
    i2 = len(s2) ; i3 = len(s3)
    return n1 + Fraction(n2,10**i2) + Fraction(n3,10**i2*(10**i3-1))

# N.B. le test __name__ == '__main__' permet d'importer ce fichier sans
# effectuer les tests.

if __name__ == '__main__':
    r1 = rationalise('17','03','25')
    print('17.032525252525... <-->',r1)
    print('Vérification :',float(r1))
    print()
    r2 = rationalise('0','','9')
    print('0.9999999999... <-->',r2)
    print('Vérification :',float(r2))
    print()
    r3 = rationalise('12','134','0')
    print('12.134 <-->',r3)
    print('Vérification :',float(r3))
    
    # COMPLEMENTS EN LIGNE
    from webbrowser import open as browse
    #browse('https://fr.wikipedia.org/wiki/Nombre_rationnel')
    #browse('http://villemin.gerard.free.fr/Wwwgvmm/Type/Ration.htm#Fraction')

