#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_rechseq.py (11.63)
Recherche séquentielle dans une liste non triée.
"""

def dans(x,L):      # coût O(n) si L est de longueur n
    '''Retourne True si x appartient à la liste L, False sinon.'''
    for y in L:
        if y == x: return True
    return False

def indice(x,L):    # recherche séquentielle de gauche à droite
    '''Retourne le plus petit indice i tel que L[i] == x, ou bien
    False si x n'est pas dans L.'''
    for i in range(len(L)):
        if L[i] == x: return i
    return False

def indices_v1(x,L):
    '''Retourne la liste croissante des indices de x dans la liste L'''
    res = []
    for i in range(len(L)):
        if L[i] == x:
            res.append(i)
    return res

def indices_v2(x,L):       # version plus pythonesque
    '''Retourne la liste croissante des indices de x dans la liste L'''
    return [i for i in range(len(L)) if L[i] == x]

if __name__ == '__main__':
    L = [2,7,5,3,1,-8,0,1,-4,1]
    print('L =',L)
    print()
    print('1 est dans L :',dans(1,L))
    print('6 est dans L :',dans(6,L))
    print()
    print('Indice de 1 dans L :',indice(1,L))
    print('Indice de 6 dans L :',indice(6,L))
    print()
    print('Indices (v1) de 1 dans L :',indices_v1(1,L))
    print('Indices (v1) de 3 dans L :',indices_v1(3,L))
    print('Indices (v1) de 6 dans L :',indices_v1(6,L))
    print()
    print('Indices (v2) de 1 dans L :',indices_v2(1,L))
    print('Indices (v2) de 3 dans L :',indices_v2(3,L))
    print('Indices (v2) de 6 dans L :',indices_v2(6,L))

    # COMPLEMENTS EN LIGNE
    from webbrowser import open as browse
    #browse('https://fr.wikipedia.org/wiki/Recherche_séquentielle')

