#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_sablier.py (11.41)
Vidages et remplissages de sabliers, par récurrence.
Mais vous êtes invités à les écrire aussi en itératif, et comparer.
"""

def vidage(s):                   # par récurrence sur s, s non vide
    if len(s) <= 1: return s
    return s + '\n' + vidage(s[:-1])

def vider(s):                   # sans résultat, juste un effet !
    if len(s) == 0: return
    print(s)
    vider(s[:-1])

def vider(s):                   # une autre stratégie 
    print(vidage(s))
    
def sablier_gauche(s):          # récursif, s non vide
    '''Premier essai. Retourne un sablier collé à la marge gauche.
    On suppose len(s) > 2.'''
    if len(s) <= 1: return s
    return s + '\n' + sablier_gauche(s[:-1]) + '\n' + s

def sablier(s):               # récursif, s non vide, m est la distance à la marge gauche
    '''Version améliorée. Retourne un sablier centré.
    m est la distance à la marge gauche. On suppose len(s) >= 2.'''
    # J'ai besoin d'un argument supplémentaire m (marge), d'où une sous-fonction:
    def recur(s,m):
        if len(s) <=2: return m * ' ' + s
        return m * ' ' + s + '\n' + recur(s[1:-1],m+1) + '\n' + m * ' ' + s
    return recur(s,0)

if __name__ == '__main__':
    print("a) vidage récursif de 'abcde' :")
    s1 = vidage('abcde')
    print('-->',repr(s1))       # faites bien la différence...
    print(s1)                   # ...entre ces deux lignes !
    print()
    print("b) essai : sablier gauche récursif sur 'abcde' :")
    s2 = sablier_gauche('abcde')
    print('-->',repr(s2))
    print(s2)
    print()
    print("sablier centré récursif sur 'abcde' :")
    s3 = sablier('abcdefg')
    print('-->',repr(s3))
    print(s3)
    print()
    print('-------- avec effet ------------')
    print()
    print("c) vidage de 'abcde' :")
    vider('abcde')             # résultat : None

