#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_sdt2.py (11.61)
Régime permanent d'un système dépendant du temps.
Evolution d'une fonction soumise à une équation différentielle du 1er ordre.
y = f(t) est un signal fonction du temps, soumis à l'équation f'(t) = 1 - f(t), f(0) = 0
Faire afficher les valeurs de f(t) pour t dans [0,8]. Montrer que f(t) converge.
Et surtout faites afficher la courbe obtenue y = f(t).

NB. Il s'agit d'un exemple simple. Si l'on sait résoudre les équations différentielles
du 1er ordre, on trouvera vite la solution exacte f(t) = 1 - exp(-t) qui tend vers 1
lorsque t tend vers l'infini... Mais le fichier exo_sdt1.py revenait à la définition
d'une dérivée...
"""

# Compléments en ligne
from webbrowser import open as browse
#browse('http://apprendre-python.com/page-creer-graphiques-scientifiques-python-apprendre')
#browse('https://matplotlib.org/tutorials/introductory/pyplot.html#sphx-glr-tutorials-introductory-pyplot-py')

# On stocke les points (t,y) dans deux listes de même longueur Lt et Ly :
(t, y) = (0, 0)            # conditions initiales
dt = 0.1                   # discrétisation (débit en petits bouts) du temps
Lt = [t] ; Ly = [y]
for i in range(100):    
    (t, y) = (t + dt, (1 - dt) * y + dt)
    Lt.append(t) ; Ly.append(y)

# et on affiche la courbe avec matplotlib (voir la doc en ligne)
import matplotlib.pyplot as plt
plt.plot(Lt,Ly, 'r-')     # 'r-' signifie red/ligne, essayez 'b.' : blue/point
plt.show()



    
    

                
    


    

