#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_stirling.py (11.9)
Vérification expérimentale de la formule de Stirling :
    n! ~ sqrt(2*pi*n) * (n/e)**n   pour n -> +infini
"""

from math import sqrt, log, e, pi

def fac(n):                # pour tout n entier >= 0
    res = 1
    for i in range(2,n+1) :
        res = res * i
    return res

def stirling_fac(n):       # pour n flottant grand (mais pas trop)
    return sqrt(2*pi*n) * (n/e)**n

f = fac(100)
fs = stirling_fac(100)      # attention au débordement des flottants !
print('100! =',f,'  :',len(str(f)),'chiffres')
print()
print('100! approché par Stirling :',fs)
print('f/fs =',f/fs)
print()

########### Stirling ou Gamma ? ####################################
# Python fournit en option la fonction 'gamma' des matheux, qui prolonge
# aux nombres réels (sauf aux entiers <= 0) la fonction n! définie sur les
# entiers naturels : n! == gamma(n+1) à la précision flottante près, 
# au sens où gamma(n+1)/fac(n) tend vers 1 pour n tendant vers +infini.

from math import gamma, factorial
print('La factorielle, et la fonction gamma dans le domaine réel :')
print('20 !       =',factorial(20))
print('gamma(19)  =',gamma(21),'~ 20!')
print('gamma(0.5) =',gamma(0.5),'est définie par une intégrale...')

# COMPLEMENTS EN LIGNE
from webbrowser import open as browse
#browse('https://fr.wikipedia.org/wiki/Formule_de_Stirling')
#browse('https://fr.wikipedia.org/wiki/Fonction_gamma#Formule_asymptotique_de_Stirling')



