#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_tarc.py (11.53)
Tracé d'une courbe à partir de ses équations paramétriques.
"""

from turtle_init import *         # cf ci-dessous
# init(x=0,y=0,cap=0,msg='',xmsg=0,ymsg=250)
# afficher(msg,x,y)
# sleep(dt)            en secondes flottantes
# deg_rad(a_degres)    conversion degrés -> radians
# rot(M,K,a_degres)    K = centre de rotation
# segment(M1,M2)       le tracé
# pi, sqrt, sin, cos, randint   pour les calculs fréquents

def axes() :
    '''Affiche les axes, dans un repere orthogonal avec l'origine au centre.'''
    segment((-300,0),(300,0)) ; up() ; goto(270,5) ; down() ; write('x',font=('Arial',20))
    segment((0,-300),(0,300)) ; up() ; goto(8,270) ; down() ; write('y',font=('Arial',20))

def paramplot(f,g,a,b,dt=0.01,u=50,v=50) :
    '''Affiche la courbe x=f(t), y=f(t) pour t dans [a,b], le temps t etant
    decoupe en tranches dt. Les parametres u et v representent les longueurs des
    vecteurs unitaires sur Ox et Oy. Le repere est orthogonal, origine au centre.'''
    # positionnement au point de départ de l'arc
    t = a
    (x,y) = (f(a)*u, g(b)*v)     # (x,y) est le "point courant"
    pen = isvisible()
    ht() ; up() ; goto(x,y) ; down() ; st()
    if not pen : ht()
    while t < b :               # je suis sur le point (x,y) au temps t
        t = t + dt              # le temps suivant t
        t = min(t,b)            # ne pas dépasser b...
        (xs,ys) = (f(t)*u,g(t)*v)
        goto(xs,ys)
        (x,y) = (xs,ys)          # mise à jour du point courant

if __name__ == '__main__' :

    clear()
    ht()
    tracer(False)
    axes()
    paramplot(lambda t : sin(2*t),lambda t : cos(3*t),-2*pi,2*pi,u=100,v=100)
    afficher('Courbe de Lissajou',0,190)
    afficher('x=cos(3t), y=sin(2t)',0,160)
    tracer(True)

    getcanvas().postscript(file='arc.ps')     # pour avoir un fichier image du canevas

    sleep(3)
    clear()
    tracer(False)
    init(0,0,0)
    ht()
    axes()
    paramplot(lambda t : sin(t)**3,lambda t : cos(t)-cos(t)**4,0,2*pi,u=100,v=100)
    afficher('x=sin(t)**3,y=cos(t)-cos(t)**4',0,190)
    tracer(True)

    sleep(3)
    clear()
    tracer(False)
    init(0,0,0)
    ht()
    axes()
    paramplot(lambda t : t**3,lambda t : t**2,-2,2)   # le "cusp" x**2 == y**3
    afficher('x=t**3,y=t**2',0,190)
    tracer(True)

    mainloop()
    print('Fini')

    # COMPLEMENTS EN LIGNE
    from webbrowser import open as browse
    #browse('https://www.apprendre-en-ligne.net/MADIMU2/ANALY/ANALY6.PDF')
