#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_tarcpol.py (11.54)
Tracé d'une courbe à partir de son équation polaire
(en utilisant le traceur de courbes paramétriques du §11.53)
"""

from exo_tarc import *

# Soit à tracer la courbe d'équation polaire r = cos(2*theta) qui donne
# le module (distance du point M à l'origine) en fonction de l'angle
# polaire theta. Les formules de passage des coordonnées polaires aux
# coordonnées cartésiennes sont :
#                  x = r*cos(theta), y = r*sin(theta)
# On transforme (à la main) l'équation polaire en équations paramétriques
# en posant theta = t, d'où :
#                  x = cos(t)*sqrt(cos(2*t)), y = sin(t)*sqrt(cos(2t))
# Problème : cos(2*t) doit être >= 0, soit t dans [-pi/4,pi/4] ou
# [3*pi/4,5*pi/4]. Problème de "zéro négatif" possible aux points
# k*pi/4. On les gère avec une exception  et on superpose les deux
# morceaux de la courbe.

def sqcos2(t):   # sur [-pi/4,pi/4] U [3*pi/4,5*pi/4], pb aux bornes !
    try: return sqrt(cos(2*t))
    except: return 0

ht()
clear()
tracer(False)
axes()
paramplot(lambda t: cos(t)*sqcos2(t),lambda t: sin(t)*sqcos2(t),-pi/4,pi/4,u=200,v=200)
paramplot(lambda t: cos(t)*sqcos2(t),lambda t: sin(t)*sqcos2(t),3*pi/4,5*pi/4,u=200,v=200)
afficher('Lemniscate de Bernoulli',0,170)
tracer(True)
getcanvas().postscript(file='lemniscate.ps')     # pour avoir un fichier image
sleep(3)

# Ralentissement de la tortue pour voir un mobile parcourir la
# lemniscate :

tracer(False)
init(0,0,0)
st()
tracer(True)
shape('circle')
paramplot(lambda t: cos(t)*sqcos2(t),lambda t: sin(t)*sqcos2(t),-pi/4,pi/4,u=200,v=200)
paramplot(lambda t: cos(t)*sqcos2(t),lambda t: sin(t)*sqcos2(t),3*pi/4,5*pi/4,u=200,v=200)

mainloop()
print('Fini.')

# COMPLEMENTS EN LIGNE
# Solution plus propre : trouver des équations paramétriques différentes
# avec de bons changements de variables, le mieux en trigo étant t' = tan(t/2)
# Voir la wikipedia :
from webbrowser import open as browse
#browse('https://fr.wikipedia.org/wiki/Lemniscate_de_Bernoulli')
