#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_tbisec.py (11.50)
Premiers exemples de graphismes polaire et cartésien.
"""

# -------------------------------------------------------------

from turtle_init import *    # fichier d'utilitaires tortue qui ajoute :
# from turtle import *
# init(x=0,y=0,cap=0)
# afficher(msg,x,y)
# sleep(dt)            en secondes flottantes
# deg_rad(a_degrés)    conversion degrés -> radians
# rot(M,K,a_degrés)    K = centre de rotation
# segment(M1,M2)       le tracé d'un segment
# pi, sqrt, sin, cos, randint   pour les calculs fréquents

#--------------------------- POLAIRE --------------------------
def equibis_polaire(c) :
    '''Dessine un triangle equilateral et ses bissectrices en POLAIRE'''
    for i in range(3) :
        forward(c)
        left(150)
        forward(c)
        back(c)
        right(30)

# tracé rapide
tracer(False)      # dessin dans un canevas invisible
reset()
init(50,0,0)
afficher('POLAIRE RAPIDE',140,240)
equibis_polaire(200)
tracer(True)       # vidage à l'écran du canevas invisible
sleep(3)

# le même tracé lent, le "tracer" reste à True
init(-250,0,0)
pencolor("blue")
afficher('POLAIRE LENT',-150,240)
equibis_polaire(200)
sleep(3)           # dodo

#--------------------------- CARTESIEN --------------------------

def equibis_cartésien(c) :
    '''Dessine un triangle equilateral et ses bissectrices en CARTESIEN.
    Triangle de base A(-c/2,0)------B(c/2,0).'''
    A = (-c/2,0) ; B = (c/2,0) ; C = (0,c*sqrt(3)/2)      # on calcule, en cartésien...
    afficher('A',-c/2-15,-5) ; afficher('B',c/2+15,-5) ; afficher('C',0,C[1]+5)
    segment(A,B) ; segment(B,C) ; segment(C,A)
    # les extrémités I,J,K des bissectrices s'obtiennent par rotations d'angle 30°
    I = rot(B,A,30) ; J = rot(C,B,30) ; K = rot(A,C,30)
    segment(A,I) ; segment(B,J) ; segment(C,K)
    afficher('I',I[0]+10,I[1]-5) ; afficher('J',J[0]-8,J[1]-5) ; afficher('K',K[0],K[1]-27)

# tracé rapide
pencolor("black")
tracer(False)
reset()
init(-100,0,0)
afficher('CARTESIEN RAPIDE',0,270)
equibis_cartésien(200)
tracer(True)
sleep(3)

# tracé lent
reset()
pencolor("red")
init(-100,0,0)
afficher('CARTESIEN LENT',0,270)
equibis_cartésien(200)

# bonus
getcanvas().postscript(file='equibis.ps')     # pour avoir un fichier image du canevas

mainloop()
print('Fini.')




