#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_tchaos.py  (11.55)
Le jeu du chaos
"""

from turtle_init import *         # cf ci-dessous
# init(x=0,y=0,cap=0)
# afficher(msg,x,y)
# sleep(dt)            en secondes flottantes
# deg_rad(a_degres)    conversion degrés -> radians
# rot(M,K,a_degres)    K = centre de rotation
# segment(M1,M2)       le tracé
# pi, sqrt, sin, cos, randint   pour les calculs fréquents

def chaos(n) :           # le jeu du chaos. On represente un point par un tuple (x,y)
    # les sous-fonctions utilitaires (je decoupe au maximum pour l'exemple !)
    def moyenne(x,y) :
        return (x + y) / 2
    def milieu(P,Q) :    # tuple x tuple --> tuple
        return (moyenne(P[0],Q[0]),moyenne(P[1],Q[1]))
    def afficher_le_point(P) :
        up() ; goto(P) ; dot(2)
    def point_au_hasard_parmi(P,Q,R) :
        return (P,Q,R)[randint(0,2)]
    # le programme principal de la fonction se lit alors aisement :
    A = (0, 200) ; B = (-200, -200) ; C = (200, -200)
    M = (randint(-300,300),randint(-300,300))   # le point courant M choisi au hasard
    afficher_le_point(M)
    for i in range(n) :                   #    "faire n fois : ..."
        S = point_au_hasard_parmi(A,B,C)
        M = milieu(M,S)
        afficher_le_point(M)

getcanvas().focus_force()    # getcanvas() --> la fenêtre graphique

clear()
ht()
bgcolor(0,0,0)              # fond noir
pencolor('yellow')
tracer(False)
afficher('Le JEU du CHAOS',0,260) ; afficher('(rapide)',0,230)
afficher('triangle de Sierpinsky',0,-250)
chaos(5000)
tracer(True)
sleep(4)

clear()
afficher('Le JEU du CHAOS',0,260) ; afficher('(lent)',0,230)
speed('fastest')
chaos(5000)

mainloop()
print('Fini.')

# COMPLEMENTS EN LIGNE
from webbrowser import open as browse
browse('https://fr.wikipedia.org/wiki/Jeu_du_chaos')