#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_tripm.py (11.79)
Utilisation des arguments nommés 'key' et 'reverse' avec .sort et sorted.
"""

L = [2,3,1,-4,-5,7,6,4]
print('>>> L\n-->',L)
print('# Tri de L en décroissant :')
print('>>> sorted(L,reverse=True)\n-->',
      sorted(L,reverse=True))
print('# Tri plaçant les pairs avant les impairs :')
print('>>> sorted(L,key = lambda x : x%2)\n-->',
      sorted(L,key = lambda x : x%2))
print('# Tri plaçant les impairs avant les pairs :')
print('>>> sorted(L,key = lambda x : 1-x%2)\n-->',
      sorted(L,key = lambda x : 1-x%2))
print('# Autre solution, en utilisant reverse :')
print('>>> sorted(L,key = lambda x : x%2,reverse=True)\n-->',
      sorted(L,key = lambda x : x%2,reverse=True))
print()

L = [(3,'a',4),(8,'b',1),(5,'a',6),(1,'c',8),(1,'b',5),(4,'a',1)]
print('>>> L\n-->',L)
print("# Tri de tuples t par-rapport au second élément :")
print('>>> sorted(L,key = lambda t : t[1])\n-->',
      sorted(L,key = lambda t : t[1]))
print('# Une autre solution avec itemgetter(1) :')
from operator import itemgetter
print('>>> sorted(L,key = itemgetter(1))\n-->',
      sorted(L,key = itemgetter(1)))
print("Tri de tuples par-rapport à t[1] d'abord et t[0] ensuite :")
print('>>> sorted(L,key = lambda t : (t[1],t[0]))\n-->',
      sorted(L,key = lambda t : (t[1],t[0])))

# COMPLEMENT EN LIGNE
from webbrowser import open as browse
#browse('https://docs.python.org/fr/3.7/library/stdtypes.html#list.sort')

