#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_trisel.py (11.74)
Tri par sélection d'une liste de nombres.
"""

def tri_sel(L):
    '''Tri par sélection (croissant) d'une liste de nombres, sur place.'''
    n = len(L)
    for i in range(n-1):
        m = imin(L,i)               # indice du min à partir de L[i]
        (L[i],L[m]) = (L[m],L[i])   # échange !

def imin(L,i):                      # version courte mais moins efficace
    '''Retourne l'indice dans L du minimum de L à partir de l'indice i inclus.'''
    S = L[i:]                       # car on "paye" une tranche (recopie)...
    return i + S.index(min(S))

def imin(L,i):
    '''Retourne l'indice dans L du minimum de L à partir de l'indice i inclus.'''
    im = i                          # indice cherché du minimum
    for j in range(i+1,len(L)):     # allons voir s'il est plus loin
        if L[j] < L[im] : im = j
    return im

if __name__ == '__main__':
    print('Le tri par sélection (voir "tri_sel.pdf")')
    if imin([3,1,7,9,2,4,7],2) != 4 : raise ValueError('Bug dans imin')
    from time import time
    L = [3,1,7,2,9,4,7]
    print('>>> L\n-->',L)
    tri_sel(L)                      # sur place
    print('>>> tri_sel(L)              # aucun résultat')
    print('>>> L\n-->',L)
    print()
    
    from exo_chrono import test_chrono
    print('Temps de calcul avec deux listes aléatoires\nà 5000 et 10000 éléments :')
    print(test_chrono(tri_sel,5000))
    print('Cela vous semble-t-il quadratique ?...')
          
    # COMPLEMENTS EN LIGNE
    from webbrowser import open as browse
    #browse('https://www.toptal.com/developers/sorting-algorithms')
    #browse('https://fr.wikipedia.org/wiki/Tri_par_sélection')
    
    


