#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_ulistes (11.96)
Réunion, intersection et différence de deux listes sans répétitions
et non ordonnées. On suppose qu'il n'y a pas de type 'set'.
"""

# E et F désignent des listes non ordonnées et sans répétitions (pensées
# comme des "ensembles" dans un Python dépourvu de type "set").

def intersection(E,F):
    return [x for x in E if x in F]     # compréhension de liste !

def difference(E,F):
    return [x for x in E if x not in F] # idem

def reunion(E,F):
    return E + difference(F,E)

def parties(E):                   # récurrence sur le nombre d'éléments de E
    if E == []: return [[]]       # 2**0 == 1
    (x,*R) = E                    # choix d'un élément dans E par déstructuration
    hr = parties(R)               # hypothèse de récurrence
    return hr + [reunion([x],P) for P in hr]
    
if __name__ == '__main__':
    E = [3,2,4]
    F = [6,3,5,2,1]
    print('>>> E\n-->',E)
    print('>>> F\n-->',F)
    print()
    print('>>> reunion(E,F)       # E \u22c3 F\n-->',reunion(E,F))
    print('>>> intersection(E,F)  # E \u22c2 F\n-->',intersection(E,F))
    print('>>> difference(E,F)    # E - F\n-->',difference(E,F))
    print('>>> parties(E)         # P(E)\n-->',parties(E))

    # COMPLEMENTS EN LIGNE 
    from webbrowser import open as browse
    #browse('https://fr.wikipedia.org/wiki/Opération_ensembliste')
    #browse("https://fr.wikipedia.org/wiki/Algèbre_des_parties_d'un_ensemble")
    