#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_zalgo.py (11.82)
Les diacritiques Unicode utilisés ont pour numéros hexa 0300-036F
"""

# Listes trouvées sur U0300.pdf

HAUT = [[0x0300,0x0315],0x031a,0x031b,[0x033d,0x0344],0x0346,[0x034a,0x034c],
        [0x0350,0x0352],0x0357,0x0358,0x035b,0x035d,0x035e,0x0360,0x0361,
        [0x0363,0x36f]]

BAS = [[0x0316,0x0319],[0x031c,0x0333],[0x0339,0x033c],0x0345,[0x0347,0x0349],
       0x034d,0x034e,[0x0353,0x0356],0x0359,0x035a,0x035c,0x035f,0x0362]

MILIEU = [[0x0334,0x0338]]

# Expansion des sous-listes

def expanse(L):
    res = []
    for x in L:
        if type(x) == list:
            [a,b] = x
            res.extend(list(map(chr,range(a,b+1))))
        else:
            res.append(chr(x))
    return res

HAUT = expanse(HAUT)
BAS = expanse(BAS)
MILIEU = expanse(MILIEU)

# Génération du texte stylisé à la Honner

from random import randint

def hasard(L):       # un élément de L au hasard
    return L[randint(0,len(L)-1)]

def tanner(msg):     # merci Howard !
    res = ''
    for c in msg:
        res += c
        for i in range(randint(0,11)) : res += hasard(HAUT)
        for i in range(randint(0,11)) : res += hasard(BAS)
        for i in range(randint(0,2))  : res += hasard(MILIEU)
    return res

if __name__ == '__main__':
    hmsg = tanner('PYTHON AND UNICODE WINNING TEAM')
    print('Hum, mauvais rendu au toplevel ?...\n\n')
    print(hmsg,'\n\n')        # au toplevel : hum...

    from tkinter import *     # mieux vaut une pleine vision !
    ROOT = Tk()
    CANVAS = Canvas(ROOT,width=800,height=280)
    CANVAS.pack()
    CANVAS.create_text(400,140,text=hmsg,font=('times',36))
    ROOT.mainloop()
    
    from webbrowser import open as browse
    #browse('http://www.unicode.org/charts/PDF/U0300.pdf')   # cf fichier 'U0300.pdf'
    #browse('https://codepen.io/dnoh126/pen/qdRGda.html')
    #browse('http://www.alanwood.net/unicode/combining_diacritical_marks.html')
    #browse('https://en.wikipedia.org/wiki/Combining_character')

    



          
