#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
gradient.py
Illustration de la technique de la descente du gradient
utilisée par exemple dans les réseaux de neurones.
"""

# ----- une fonction avec un minimum (parabole)
f = lambda x: 0.5 + (x - 1)**2
# sa dérivée
df = lambda x: 2*(x-1)
# la tangente en x=5 à la courbe de f
tg = eval('lambda x: {} + (x-5)*{}'.format(f(5),df(5)))    # y = f(a) + (x-a)*f'(a)

# ----- tracé de la courbe, pour voir...
import numpy as np
import matplotlib.pyplot as plt
# tracé de la courbe de f
x = np.linspace(-1,7,100)
y = f(x)
plt.plot(x,y,'r-')
# tracé de la tangente en x=5
x = np.linspace(3,7,2)
y=tg(x)
plt.plot(x,y,'b-')
# tracé de deux points individuels sur la courbe
plt.plot([5,1],[f(5),f(1)],'.k')
plt.show()

# ----- descente du gradient pour trouver un minimum

eta = 0.01
x = 5
for i in range(5000) :
    x = x - eta * df(x)
print('Minimum =',(x,f(x)))

# COMPLEMENTS EN LIGNE
from webbrowser import open as browse
# Pour se lancer dans la "data science" avec Python et Anaconda (en fait Jupyter) :
#browse('https://github.com/jakevdp/PythonDataScienceHandbook/tree/master/notebooks')
