#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_2_16.py
03/03/2020
"""
print('Quelques exemples de code du §2.16')
print()

from math import sqrt                     # sqrt réelle

### ligne 208

f = lambda x,y: x + sqrt(y)               # x,y sont des nombres
print('>>> f(3,2.5)',f(3,2.5),sep='\n--> ')

from cmath import sqrt                    # sqrt complexe

print('>>> f(3,-5)',f(3,-5),sep='\n--> ')
print('---------------------')

### ligne 217

def g(x,n):                               # x et n sont les "paramètres" de g
    a = x * x                             # a est une "variable locale" de g
    return a + (a + 1) ** n               # échappement avec le résultat

print('>>> g(3,2)',g(3,2),sep='\n--> ')
print('---------------------')

(a, x) = (1, 2)
print('>>> g(x,a + 2)',g(x,a + 2),sep='\n--> ')
print('>>> (a,x)',(a,x),sep='\n--> ')     # ces variables nont pas été modifiées !
# ci-dessous j'utilise une exception try...except... pour vérifier qu'il y a une erreur !
try:                                      # try pour éviter de bloquer sur erreur
    print(n)                              # et n était aussi local à la fonction g
except:                                   # et s'il y a eu une erreur (livre §5.9)...
    print("n n'existe pas !")             # mon programme n'est donc pas bloqué sur erreur.





