#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_2_18.py
03/03/2020
"""
print('Quelques exemples de code du §2.18')
print()

### ligne 261

def f(x,y,z):              # trois paramètres positionnels x, y, z
    return x - y + 2 * z

# on passe dans l'ordre 3 à x, 1 à y et 0 à z
print('>>> f(1+2,1,0)',f(1+2,1,0),sep='\n--> ')
print('---------------------')

### ligne 265

def f(x,y,z): 
    return x - y + 2 * z

print('>>> f(y=1,z=0,x=1+2)',f(y=1,z=0,x=1+2),sep='\n--> ')
print('---------------------')

### ligne 269

def f(x,y=3,z=2):         # x est obligatoire, y et z sont optionnels
    return x - y + 2 * z

print('>>> (f(1+2,1,0),f(1+2,6),f(1+2,z=8),f(1+2))',
      (f(1+2,1,0),f(1+2,6),f(1+2,z=8),f(1+2)),sep='\n--> ')
print('---------------------')

### ligne 273

def f(x,y,*args):    # args est le tuple des arguments optionnels
    return (x,y,args)

print('>>> f(3,4,5,6,7,8)',f(3,4,5,6,7,8),sep='\n--> ')      # coupure (split) après le 2ème argument
print('---------------------')

### ligne 277

def foo(x,y,*args,**kwargs):
    return (x,y,args,kwargs)

print(">>> foo(3,4,5,6,7,8,couleur='rouge',prix=2500)",
      foo(3,4,5,6,7,8,couleur='rouge',prix=2500),sep='\n--> ')     # 2 coupures


