#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_2_23.py
03/03/2020
"""
print('Quelques exemples de code du §2.23')
print()

### ligne 331

print('>>> from math import factorial')
from math import factorial
print('>>> factorial(5)',factorial(5),sep='\n--> ')
print('>>> len(str(factorial(10000)))',len(str(factorial(10000))),sep='\n--> ')
print('---------------------')

print('La factorielle récursive :')

def fac(n):           # la factorielle n! récursive pour n entier >= 0
    if n == 0: return 1      # cas de base : 0! == 1, échappement
    return n * fac(n - 1)    # else est sous-entendu ici

print('>>> fac(5)',fac(5),sep='\n--> ')

try:
    print('>>> fac(3000)')
    print(fac(3000))                                               # ça casse !?
except:
    print('RecursionError: profonde maximale de récursion atteinte !')
print('---------------------')

print('>>> from sys import setrecursionlimit')
from sys import setrecursionlimit
print('>>> setrecursionlimit(3100)')
setrecursionlimit(3100)
print('>>> len(str(fac(3000)))',len(str(fac(3000))),sep='\n--> ')  # ça passe !
print()

# ------- § 2.23.1 : tracer une fonction récursive --------

# ligne 347

from code_trace import trace      # fichier code_trace.py
fac = trace(fac)                  # fac devient tracée
print('# trace du calcul de fac(5) :')
print('>>> fac(5)')
print(fac(5))
print()

# ------- § 2.23.2 : le rôle de la pile de récursion (IMPORTANT) --------

# ligne 376

def fac_term(n):
    return aux(1,n)

def aux(p, q):
    if q == 0: return p
    return aux(p*q, q-1)     # appel récursif TERMINAL !

aux = trace(aux)
print('# trace du calcul de aux(1,5) :')
print('>>> aux(1,5)')
print(aux(1,5))              # la remontée de pile est devenue constante à 120.

# la factorielle n! pour n entier ≥ 0 # pourrait être locale à fac_term
# la récurrence est dite "terminale"

# Le cas de CYTHON
# Il faut entrer le code du livre page 46 directement à la console de Spyder (IPython) !
# Ne fonctionne pas sous IDLE...

