#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_5_6.py
03/03/2020
"""

print('Quelques exemples de code du §5.6')
print()

print('Partage de mémoire.')

# ligne 835

def incr(x):            # la fonction qui ne fait rien...
    x = x + 1
    
y = 3
incr(y)
print('Après incr(y), y vaut toujours',y) 
print()

# ligne 861

def augmenter(L):       # la fonction qui ne fait rien...
        L = L + [40]    # une AFFECTATION, pas une mutation !

V = [10,20,30]
augmenter(V)
print('Après augmenter(V), V vaut toujours',V) 
print()

# ligne 847

def incr0(L):
    L[0] = L[0] + 1     # mais ceci est une MUTATION !
    
V = [10,20,30]
print('id(V) =',id(V))
incr0(V)                # la \underline{valeur} de V est passée à incr0
print('Après incr0(V), V a changé et vaut',V)
print('mais id(V) vaut toujours',id(V),' (même adresse mémoire)')
print()

# ligne 853

def ajouter(x,L=[]):    # c'est *maintenant* que L est mis à []
    L.append(x)
    return L

print('Initialisation par défaut au moment de la définition !')
L1 = ajouter(5)
print('Après ajouter(5), L1 vaut',L1)
L2 = ajouter(6)
print('Après ajouter(6), L1 vaut',L1,'et L2 vaut',L2)
print('L1 is L2 :',L1 is L2)
print()

# ligne 860

print("Egalité d'adresses (1)")
L1 = [10,20,30]         # une liste implantée en mémoire
L2 = L1                 # un alias de L1, pas une nouvelle liste
L3 = L1[:]              # une copie de L1, ailleurs en mémoire
L1 == L2 == L3          # elles s'affichent toutes [10,20,30]
print('L2 is L1 :',L2 is L1)      # L1 et L2 sont deux alias d'une même liste
print('L3 is L1 :',L3 is L1)      # L3 et L1 sont la MEME liste en mémoire !
print()

# ligne 869

print("Egalité d'adresses (2)")
L1 = [10,20,30]
L2 = L1                 # L1 et L2 font référence au même objet
L3 = L1[::]             # une copie de L1, ailleurs en mémoire
print('id(L1) =',id(L1))
print('id(L2) =',id(L2))     # L2 is L1
print('id(L3) =',id(L3))     # L3 is not L1
print('>>> [1,2] == [1,2]\n-->',[1,2] == [1,2])
print()

# ligne 878
x = 5634
y = 5634
print('>>> x is y\n-->',x is y,'      (essayez au toplevel !)')

