#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_5_8.py
03/03/2020
"""

print('Quelques exemples de code du §5.8')
print()

print('Les dictionnaires.')

# ligne 928

dico = {'pommes':15, 'bananes':7, 'poires':4, 'kiwis':18}
print('>>> dico\n-->',dico)
print('>>> type(dico)\n-->',type(dico))
print('>>> len(dico)   # comme dans toutes les collections')
print(len(dico))
print()

# ligne 933

print(">>> 'kiwis' in dico\n-->",'kiwis' in dico)
print(">>> dico['kiwis']      # accès par clé\n-->",dico['kiwis'])
print(">>> 'abricots' in dico\n-->",'abricots' in dico)
print(">>> dico['abricots']")
try:
    dico['abricots']
except KeyError:
    print("KeyError: 'abricots'   (Cette clé n'existe pas !)")
print()

# ligne 941

def foo(a,b,*L,**d):
    return d

print('>>> foo(1,2,3,4,y=8,x=2)\n-->',foo(1,2,3,4,y=8,x=2))
print()

# ligne 945

print('for k in dico:     # pour toutes les clés k de dico')
print("    print(dico[k],end=' ')")
for k in dico : print('{}-{}'.format(k,dico[k]),end=' ')
print('\n')

# ligne 948

print('>>> dico\n-->',dico)
dico['poires'] += 1                 # modification d'un élément
print("# Après dico['poires'] += 1 :")
print('>>> dico\n-->',dico)
dico['abricots'] = 12               # introduction d'un élément
print("# Après dico['abricots'] = 12 :")
print('>>> dico\n-->',dico)
del dico['poires']                  # suppression d'un élément
print("# Après del dico['poires'] :")
print('>>> dico\n-->',dico)
print()

# ligne 957

d1 = {1:2, 2:5, 3:2} ; d2 = {4:2, 1:6}
print('>>> d1 == {} et d2 == {}'.format(d1,d2))
d1.update(d2)
print('# Après d1.update(d2) :')
print('>>> d1 == {} et d2 == {}'.format(d1,d2))
print()

# ligne 961

vals = d1.values()
print('>>> vals\n-->',vals)
print('>>> set(vals)\n-->',set(vals))
print()

# ligne 966

print('>>> hash(2021), hash(12345678901234567890), hash(0.5)')
print('-->',hash(2021), hash(12345678901234567890), hash(0.5))
print(">>> hash('foo')\n-->",hash('foo'))
try:
    print('>>> hash([3,4,1,5])')
    print(hash([3,4,1,5]))
except:
    print("TypeError: type non hashable: 'list'")
    print('# (une liste est mutable...)')



