#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_6_2.py
03/03/2020
"""

# Codes du §6.2 - Fichiers en sortie.
print('Ecriture dans un fichier.')
print()

# ligne 1027

f_out = open('table5.txt','w', encoding='UTF-8')

def creer_fichier(f):
    f_out.write("Pour l'élève: table de multiplication par 5\n")
    for i in range(1,3):     # juste les deux premières lignes
        f_out.write('5 * {} = {}\n'.format(i,5*i))

creer_fichier(f_out)
f_out.close()                # fermez le port !

import os
if not os.path.isfile('table5.txt'):
    raise ValueError("### Le fichier n'a pas été créé !")
else:
    print('Le fichier "table5.txt" existe sur le disque.')
print()

# On peut rajouter des lignes à la fin du fichier.
f_out = open('table5.txt', 'a', encoding='UTF-8')   # mode 'a'
f_out.write('Fin de la table.\n')
f_out.close()

# Vérifions avec un "appel système" (lecture optionnelle)
import subprocess
cmd = 'type' if os.name == 'nt' else 'cat'         # windows is not unix...
s = subprocess.run(['cat','table5.txt'],capture_output=True).stdout
# s est une "chaîne binaire"   b'xxxxxx' qu'il faut "décoder" !
print('Vérification :')
print('----------------------')
print(s.decode(encoding='utf-8'))   # utf-8 par défaut...
print('----------------------')

from webbrowser import open as browse
#browse('https://fr.wikipedia.org/wiki/UTF-8')
#browse('https://docs.python.org/fr/3/howto/unicode.html')   # pour s.decode !
