#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_6_4.py
03/03/2020
"""

print('Quelques exemples de cdes du §6.4 - Fichiers en mémoire centrale')
print()

# ligne 1065

import io
f = io.StringIO()          # un fichier texte en mémoire, vide
# La doc Python nomme f un "flot" (stream)...
f.write('Les températures sont:\n')    # résultat omis
n = f.write('3 6 -2\n')
print('Ecriture de',n,'caractères.')
print()

print('>>> f.getvalue()\n-->',repr(f.getvalue()))
print()

# ligne 1071

# pointeur de fichier au début
print(">>> f.seek(0)            # pointe sur l'octet 0 (reset)")
f.seek(0)
print('>>> f.readline()\n-->',repr(f.readline()))
print('>>> f.readline()\n-->',repr(f.readline()))
print('>>> len(f.readline())    # ligne vide : EOF\n-->',
      len(f.readline()))
print('# donc f est un "file-like object" :-)')
print()

# ligne 1079

from contextlib import redirect_stdout     # redirection de sortie 
incidents = io.StringIO()                  # un flot d'erreurs...
for (i,p) in enumerate([12,-450,123,-10,25]):
    if p > 0: 
        print(p,end=' ')
    else: 
        with redirect_stdout(incidents):   # redirection locale
            print(p,end=' ')               # de print !
print('\nIncidents advenus :',end=' ')
print(incidents.getvalue())               # les incidents < 0

from webbrowser import open as browse
#browse('https://webkul.com/blog/using-io-for-creating-file-object/')
#browse('https://docs.python.org/fr/3.7/library/io.html?highlight=stringio#io.StringIO')

       