#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_7_4.py
03/03/2020
"""

print('Quelques exemples de codes du §7.4')
print("(boucle for et itérateurs)")
print()

# ligne 1226

e = range(5)
print(">>> for x in e : print(x,end=' ')")
for x in e : print(x,end=' ')
print('\n')

e = range(3)     # un objet itérable
ei = iter(e)     # et son itérateur
try:
    while True:
        print(next(ei),end=' ')        # next(ei) <==> ei.__next__()
except StopIteration:
    print("StopIteration : itérateur épuisé !")
print()

# ligne 1230

e = range(3)     # un objet itérable
ei = iter(e)     # et son itérateur <==> e.__iter__()
try:
    while True:
        print(ei.__next__(),end=' ')  # méthode __next__ d'un itérateur
except StopIteration:
    print("StopIteration : itérateur épuisé !")
print()

# ligne 1250

print('# Simulation de range avec la classe My_range :')
class My_range:           # simulation de l'objet itérable range(n)
    def __init__(self,n):
        self.i = 0
        self.dernier = n-1

    def __iter__(self):
        return self

    def __next__(self): 
        if self.i > self.dernier:
            raise StopIteration        # attrapé par la boucle for
        else:
            self.i = self.i + 1
            return self.i - 1

for i in My_range(10):
    print(i,end=' ')
print('\n# My_range(10) est un objet itérable !')
print('>>> list(My_range(10))\n-->',list(My_range(10)))
print()

print('Une liste aussi par exemple est un objet itérable :')
it = iter([10,20,30])
try:
    while True:
        print(next(it),end=' ')
except StopIteration:
    print("StopIteration : itérateur épuisé !")
print()

print('Ok ?')

from webbrowser import open as browse
#browse('https://docs.python.org/fr/3/library/itertools.html')
#browse('https://docs.python.org/fr/3/howto/functional.html?highlight=itérateurs')
#browse('https://docs.python.org/fr/3/library/stdtypes.html#index-17')