#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_7_5.py
03/03/2020
"""

print('Quelques exemples de codes du §7.5')
print("(générateurs)")
print()

# ligne 1267

def gen_entiers(x):                        
    while True :
        yield x             # yield = return + reprise !
        x = x + 1

print('>>> gen_entiers\n-->',gen_entiers)   # fonction : int --> générateur
gen = gen_entiers(5)       # un générateur d'entiers à partir de 5
print('>>> gen\n-->',gen)
for i in range(10):
    print(next(gen),end=' ')      # next(gen) <==> gen.__next__()
print()
print('>>> next(gen)\n-->',next(gen))
print('>>> next(gen)\n-->',next(gen))
print('')

print('Un itérateur par compréhension !')
print('Ne confondez pas :')
print('      [x*x for x in range(5)]       # une liste')
print('      tuple(x*x for x in range(5))  # un tuple')
print('      (x*x for x in range(5))       # un générateur')
print('Cf la page Web sur medium.freecodecamp.org ci-dessous...')
print()

# ligne 1282

print('Un générateur du pauvre, à la main :')
def gen_entiers_pauvre(x):        # retourne une fermeture avec variable privée
    def next() :
        nonlocal x
        x = x + 1
        return x - 1
    return next

gen = gen_entiers_pauvre(5)      # fonction : int --> (None --> int)
for i in range(10):
    print(gen(),end=' ')         # next(gen) <==> gen.__next__()
print()

from webbrowser import open as browse
#browse('https://docs.python.org/fr/3/howto/functional.html?highlight=générateur')
#browse('http://book.pythontips.com/en/latest/generators.html')
#browse('https://medium.freecodecamp.org/how-and-why-you-should-use-python-generators-f6fb56650888')
