#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_7_7.py
03/03/2020
"""

print('Quelques exemples de codes du §7.7')
print("(les sous-classes)")
print()

# ligne 1330

class Forme():
    def __init__(self,x,y):      # initialisation d'une "forme" en x,y
        self.x = x
        self.y = y
    def __repr__(self):          # représentation externe d'un objet lisible par Python
        return 'Forme(x={},y={})'.format(self.x,self.y)
    def move(self,dx,dy):        # méthode d'instance de déplacement
        self.x += dx
        self.y += dy

# ligne 1344
        
class Cercle(Forme) :
    def __init__(self,x,y,r):
        # il y a plusieurs manières d'initialiser self dans la classe-mère:
        Forme.__init__(self,x,y)            # en Python 3
        #super().__init__(x,y)              # en Python 3, avec héritage simple
        #super(Cercle,self).__init__(x,y)   # en Python 2.7 (pour Processing)
        self.r = r

    def __repr__(self):          # redéfinition de __repr__ dans la sous-classe
         return 'Cercle({},{},r={})'.format(self.x,self.y,self.r)

    def zoom(self,k):            # ajout d'une nouvelle méthode non héritée
         self.r *= k

if __name__ == '__main__':
    f = Forme(10,25)
    print('f =',f)               # print va utiliser __repr__
    print('type(f) == Forme :',type(f) == Forme)    # en réalité __main__.Forme
    print()
    c = Cercle(10,25,r=8)
    print('c =',c)
    c.move(5,5)
    print('Le cercle c bouge de (5,5)')
    print('c =',c)
    c.zoom(2)
    print("c est agrandi d'un facteur 2")
    print('c =',c)
    print('type(c) == Cercle :',type(c) == Cercle)
    print('type(c) == Forme :',type(c) == Forme)
    print('isinstance(c,Cercle) :',isinstance(c,Cercle))
    print('isinstance(c,Forme) :',isinstance(c,Forme))   # et de toutes les sur-classes
    print('issubclass(Cercle,Forme) :',issubclass(Cercle,Forme))
