#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_7_8.py
03/03/2020
"""

print('Quelques codes du §7.8')
print("(classes abstraites)")
print()

try:
    print('>>> for k in 2021 : print(k)')
    for k in 2021 : print(k)
except:
    print("TypeError: 'int' object is not iterable")
print()

from collections import abc
print('>>> isinstance(2,abc.Iterable)')
print(isinstance(2,abc.Iterable))                   # un entier n'est pas itérable
print('>>> isinstance(range(10),abc.Iterable)')
print(isinstance(range(10),abc.Iterable))           # mais un intervalle oui
print(">>> isinstance('azerty',abc.Iterable)")
print(isinstance('azerty',abc.Iterable))            # et une chaîne aussi.
print('>>> issubclass(list,abc.MutableSequence)')
print(issubclass(list,abc.MutableSequence))         # une liste est mutable
print('>>> issubclass(str,abc.MutableSequence)') 
print(issubclass(str,abc.MutableSequence))          # mais pas une chaîne !
print()

# ligne 1374

from abc import ABC, abstractmethod

class FormeAbstraite(ABC):     # une classe abstraite
    def __init__(self,x,y):
        self.x = x
        self.y = y

    def move(self,dx,dy):      # cette méthode est implémentée
        self.x += dx           # mais peut être redéfinie
        self.y += dy

    @abstractmethod            # décorateur des méthodes abstraites
    def longueur(self):
        pass                  # méthode à implémenter !

try:
    f = FormeAbstraite(10,25)
except Exception as e:
    print(type(e).__name__,':',e)
print()

# ligne 1392

class Cercle(FormeAbstraite):
    def __init__(self,x,y,r):
        super().__init__(x,y)
        self.r = r

    def __repr__(self):
        return('Cercle(x={},y={},r={})'.format(self.x,self.y,self.r))
        
    def longueur(self):
        return 2 * pi * self.r

c = Cercle(10,25,8)
c.move(5,5)   # héritage
print('>>> c\n-->',c)
print('>>> isinstance(c,Cercle)\n-->',isinstance(c,Cercle))
print('>>> isinstance(c,FormeAbstraite)\n-->',isinstance(c,FormeAbstraite))


    

    