#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_7_9.py
03/03/2020
"""

print('Quelques exemples de codes du §7.9')
print("(les décorateurs)")
print()

# ligne 1407

def fibo(n):                               # version naïve et lente !
    if n < 2: return n
    return fibo(n-1) + fibo(n-2)

# ligne 1414
    
class Memo:
    def __init__(self, f):
        self.f = f
        self.d = {}                        # mémoire initiale vide
        
    def __call__(self,n):                  # un objet de type Memo est "callable" (invocable)
        if n not in self.d :               # pas encore calculé ?
            self.d[n] = self.f(n)          # calcul et stockage
        return self.d[n]

@Memo                          # le décorateur des mémo-fonctions : fib = Memo(fib)
def fib(n):                    # un code lent rendu automatiquement rapide !
    if n < 2: return n
    return fib(n-1) + fib(n-2) # mais toujours un pb de petite pile :-(

if __name__ == '__main__':
    from time import time
    import sys                 # on ne sait jamais :-)
    print('Calcul de fibo(35)')
    
    print('Version récursive lente :')
    start = time() ; res = fibo(35) ; end = time()
    print('fibo(35) == {} en {:.2f} sec.'.format(res, end - start))
    print()
    
    print('Calcul récursif de fib(2000) avec mémoire des calculs déjà faits :')
    try:
        start = time() ; res = fib(2000) ; end = time()
        print('fib(2000) == {}\nen {:.2f} sec.'.format(res, end - start))
        print('La mémoire de fib comporte {} neurones'.format(len(fib.d)))
    except RecursionError as e:
        print(type(e).__name__,':',e)
        print('(Oups, utilisez un sys.setrecursionlimit avant le try...)')


