#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_7_1.py
03/03/2020
"""

print('Quelques exemples de codes du §7.1')
print("(expressions régulières)")
print()

# ligne 1434

import re                  # module des expressions régulières
motif = '[A-Za-z]+ +-[1-9][0-9]*'     # une expression régulière
print('>>> motif\n-->',repr(motif))
print(">>> re.search(motif,'Le Secteur   -1483bis')\n-->",
      re.search(motif,'Le Secteur   -1483bis'))
print()

# ligne 1438

print(">>> re.search(motif,'Le Secteur 8  -1483bis')\n-->",
      re.search(motif,'Le Secteur 8  -1483bis'))
print()

# ligne 1440

print(">>> (len('a\\nb'), len(r'a\\nb'))\n-->",
      (len('a\nb'), len(r'a\nb')))
print()

phrase = 'des cadeaux pour vous et un cadeau pour toi'
sol1 = re.search('cadeau',phrase)          # première solution
print('>>> sol1\n-->',sol1)
print()

# ligne 1446

sp1 = sol1.span()
print('>>> sp1\n-->',sp1)
sl1 = slice(*sp1)
print('>>> sl1\n-->',sl1)
print('>>> phrase[sl1]      # phrase[4:10]\n-->',repr(phrase[sl1]))
print()

print('>>> sol1[0]\n-->',repr(sol1[0]))
print()

# ligne 1456

print(">>> re.findall('cadeau',phrase)\n-->",
      re.findall('cadeau',phrase))
print()

sols = re.finditer('cadeau',phrase)
print('>>> sols\n-->',sols)
print('>>> list(map(lambda s: s.span(),sols))\n-->',
      list(map(lambda s: s.span(),sols)))
print()

# ligne 1463

def match(motif, s):
    sol = re.search(motif,s)
    if sol == None : return False
    return sol[0]

print(">>> (match('cadeau',phrase), match('cadot',phrase))\n-->",
      (match('cadeau',phrase), match('cadot',phrase)))
print()

print(">>> match('^si','sinon')\n-->",
      repr(match('^si','sinon')))
print(">>> match('^si','et sinon')\n-->",
      repr(match('^si','et sinon')))
print(">>> match('non$','oui et non')\n-->",
      repr(match('non$','oui et non')))
print(">>> match('non$','non ou oui')\n-->",
      repr(match('non$','non ou oui')))
print()

print(">>> match('.','x = 3.14')\n-->",
      repr(match('.','x = 3.14')))
print(">>> match('[.]','x = 3.14')\n-->",     # <==> match('\.','x = 3.14')
      repr(match('[.]','x = 3.14')))
print()

print(">>> match('c+','abcccdef')\n-->",match('c+','abcccdef'))

print(">>> re.findall('c+','acbccdccce')\n-->",
      repr(re.findall('c+','acbccdccce')))
print(">>> match('c*','abdef')\n-->",
      repr(match('c*','abdef')))
print(">>> match('..*..','abcdef')\n-->",
      repr(match('..*..','abcdef')))
print()

# ligne 1488

sol = re.search('(.).*(..)','abcdef')           # deux groupes
print(">>> (sol[0], sol[1], sol[2])\n-->",
      repr((sol[0], sol[1], sol[2])))
try:
    print('>>> sol[3]\n-->',sol[3])
except:
    print('IndexError: no such group')
print()

print(">>> re.findall('([a-zA-Z]+)[.](jpg|gif)','foo.jpg, bar.txt et gee.gif')")
print(re.findall('([a-zA-Z]+)[.](jpg|gif)','foo.jpg, bar.txt et gee.gif'))
print()

# ligne 1495

print(">>> match('[a-z]','TH12ab')\n-->",
      repr(match('[a-z]','TH12ab')))
print(">>> match('[0-9]+','TH12ab3')\n-->",
      repr(match('[0-9]+','TH12ab3')))
print(">>> re.findall('[aie]','bateau')\n-->",
      repr(re.findall('[aie]','bateau')))
print(">>> match('[a-zP]+','3KM Paris!')\n-->",
      repr(match('[a-zP]+','3KM Paris!')))
print(">>> match('[^a-z]+','THX12ab')\n-->",
      repr(match('[^a-z]+','THX12ab')))
print(">>> match('[^a-zA-Z]+','THab12c')\n-->",
      repr(match('[^a-zA-Z]+','THab12c')))
print()

# ligne 1507

eqn = '23x+5y=-36z'
print(">>> re.split('[xyz=]',eqn)\n-->",
      re.split('[xyz=]',eqn))
print()

sol = re.search('([+-]?[0-9]+)x([+-][0-9]+)y=([+-]?[0-9]+)z',eqn)
print(">>> list(map(int,[sol[1],sol[2],sol[3]]))\n-->",
      list(map(int,[sol[1],sol[2],sol[3]])))
print()

# ligne 1513

print(">>> re.sub('(jpg|gif)','bmp','foo.jpg et bar.gif')\n-->",
      repr(re.sub('(jpg|gif)','bmp','foo.jpg et bar.gif')))
print(">>> re.sub('(jpg|gif)','bmp','foo.jpg et bar.gif',1)\n-->",
      repr(re.sub('(jpg|gif)','bmp','foo.jpg et bar.gif',1)))
print()

r = re.compile('jpg|gif')
print(">>> r.findall('foo.jpg, bar.bmp, gee.gif et quux.jpg')\n-->",
      r.findall('foo.jpg, bar.bmp, gee.gif et quux.jpg'))
print()

r = re.compile('^(0|1(01*0)*1)+$')
it = filter(lambda i : r.search(bin(i)[2:]),range(0,40))
print(">>> tuple(it)\n-->",tuple(it))
print()

from webbrowser import open as browse
#browse('https://docs.python.org/fr/3/library/re.html')
#browse('https://www.regular-expressions.info/python.html')
