#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_9_1_10.py
03/03/2020
"""

print('Quelsues exemples de codes du §9.1.10')
print('(la tortue dans une interface graphique)')
print()

# ligne 1845

from tkinter import *
from turtle import TurtleScreen, RawTurtle
from math import sin, pi

ROOT = Tk()                     # un petit programme sans classe ;-)
ROOT.geometry('+100+100')       # coin supérieur gauche
ROOT.title('Tortues dans GUI')
CANVAS = Canvas(ROOT, width=200, height=200)
CANVAS.pack()

def stopper():
    global FINI
    FINI = True

BUTTON = Button(ROOT, text='Stopper',command=stopper)
BUTTON.pack(fill=X)

SCREEN = TurtleScreen(CANVAS)   # un 'écran tortue' prend la place du canevas
lea = RawTurtle(SCREEN)

def animation(t):    # x = a sin(p t), y = b sin(q t)   pour t en radians
    # sin(p*x) et sin(q*x) a pour periode 2*pi si gcd(p,q) == 1
    if FINI: return
    if t > 2*pi: t = 0     # pour éviter les erreurs d'arrondi après plusieurs tours
    (x,y) = (a * sin(p*t), b * sin(q*t))
    lea.goto(x,y)
    # ci-dessous, t+0.5 sera le prochain argument de la fonction animation
    ROOT.after(10, animation, t + 0.05)

ROOT.focus_force()
(a,b,p,q) = (95,95,3,4)
lea.clear()
lea.shape('circle')
FINI = False
animation(0)

ROOT.mainloop()     # bloquant...
print('Fini')





