#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

'''
section_9_1_3.py
03/03/2020
'''

print('Quelques exemples de codes du §9.1.3')
print('(dessiner et écrire dans un canvas avec tkinter (GUI)')
print()

from tkinter import *

ROOT = Tk()
ROOT.title('Dessiner dans un canvas')
LARGEUR = 500   # largeur du canevas en pixels
HAUTEUR = 150   # hauteur...

(X0,Y0) = (150,50)                      # position du coin haut gauche de la fenêtre
ROOT.geometry('+{}+{}'.format(X0,Y0))   # la dimension de la fenêtre sera fixée automatiquement

print("L'écran a pour dimensions",
      ROOT.winfo_screenwidth(),'x',ROOT.winfo_screenheight())
print('Le coin haut gauche de la fenêtre est en',X0,'x',Y0)
print('Le canvas a pour dimensions',LARGEUR,'x',HAUTEUR)

CANVAS=Canvas(ROOT,width=LARGEUR,height=HAUTEUR)    # il est défini
CANVAS.pack()                 # mais seulement maintenant il est dans ROOT !

x1 = CANVAS.create_rectangle(0,0,LARGEUR,HAUTEUR,fill='yellow')
x2 = CANVAS.create_oval(10,10,LARGEUR-10,HAUTEUR-10,outline='green',fill='green')
x3 = CANVAS.create_line(0,0,LARGEUR,HAUTEUR,fill='red')
x4 = CANVAS.create_rectangle(LARGEUR/4,HAUTEUR/4,3*LARGEUR/4,3*HAUTEUR/4,
                        fill='pink',width=10)
x5 = CANVAS.create_text(LARGEUR/2,HAUTEUR/2, text="On peut écrire",
                        font=('monaco',28))

def ps() :                    # le callback du bouton
    print('Création du fichier "canvas.ps", vérifiez...')
    CANVAS.postscript(file='canvas.ps',colormode='color')

# le bouton qui va générer un fichier Postscript .ps
# à convertir au format pdf, png, ...
BUTTON = Button(ROOT,text='Postscript',fg='red',command=ps)
BUTTON.pack()

print('Objets dans le canevas :',CANVAS.find_all())     # les numéros des objets dans le CANVAS

def supprimer(i) :           # suppression de l'objet numéro i
    CANVAS.delete(i)

CANVAS.after(10000,supprimer,5)     # supprimer le texte après 3 sec (asynchrone)

ROOT.mainloop()
print('Fini')


