#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

'''
section_9_1_4.py
03/03/2020
'''

print('Quelques exemples de codes du §9.1.4')
print("(rédaction de l'interface graphique dans une classe)")
print()

from tkinter import *

class My_canvas_app(Tk):
    def __init__(self,w,h):
        Tk.__init__(self)          # <==> super().__init__()
        self.w = w
        self.h = h
        self.title('Dessiner dans un canvas avec classe')
        self.resizable(width=False,height=False)
        self.add_widgets()

    def ps(self):                  # le callback du bouton
        self.canvas.postscript(file='canvas.ps',colormode='gray') # ou 'color'

    def add_widgets(self):
        # nous ajoutons un attribut à self en-dehors de __init__ ! Hum...
        self.canvas=Canvas(self,width=self.w,height=self.h)
        self.canvas.pack()
        self.canvas.create_rectangle(0,0,self.w,self.h,
                                     outline='yellow',fill='yellow')        # objet numéro 1
        self.canvas.create_oval(10,10,self.w-10,self.h-10,
                                outline='green',fill='green')
        self.canvas.create_line(0,0,self.w,self.h)
        self.canvas.create_rectangle(self.w/4,self.h/4,3*self.w/4,3*self.h/4,
                                     fill='pink',width=10)
        self.canvas.create_text(self.w/2,self.h/2,
                                text="On peut écrire",font=('monaco',28))   # objet numéro 5
        BUTTON = Button(self,text='Postscript',fg='red',command=self.ps)
        BUTTON.pack()

if __name__ == '__main__':
    ROOT = My_canvas_app(1000,150)
    ROOT.focus_force()               # Au premier plan. Hum, un peu impoli...
    print('Objets dans le canvas :',ROOT.canvas.find_all())
    # supression du texte (objet numéro 5 du canvas) après 5 sec.
    ROOT.canvas.after(5000,lambda:ROOT.canvas.delete(5))

    ROOT.mainloop()
    print('Fini')

    from webbrowser import open as browse
    #browse('https://www.packtpub.com/application-development/tkinter-gui-application-development-blueprints')
    #browse('http://tkinter.fdex.eu/index.html')




