#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

'''
section_9_1_6.py
03/03/2020
'''

print('Quelques codes du §9.1.6')
print('(écoute des clicks de souris et du clavier dans un canvas)')
print()

from tkinter import *

class My_canvas_events_app(Tk):
    def __init__(self):
        Tk.__init__(self)
        self.L = []
        self.canvas = None        # dans add_widgets
        self.title('Canvas events')
        self.resizable(width=False,height=False)
        self.add_widgets()
        self.add_events()
        self.focus_force()        # fenêtre au premier plan, un peu impoli...

    def add_widgets(self):
        self.canvas = Canvas(self,width=300,height=300,bg='yellow',
                             borderwidth=0,highlightthickness=0)
        self.canvas.pack()
        bt = Button(self,text = 'Reset',command = self.button_callback)
        bt.pack(fill=X)

    def add_events(self):
        self.canvas.bind('<Button-1>',self.mouse_callback)
        self.bind('<Key>',self.key_callback)

    def mouse_callback(self,evt):
        #print('evt de type',type(evt),':',evt.type)
        (x,y) = (evt.x, evt.y)                             # coordonnées du clic
        self.L.append((x,y))
        self.draw_polygon()

    def key_callback(self,evt):                            # touche 'u' pour UNDO
        #print('evt de type',type(evt),':',evt.type,evt.keycode)
        if (evt.char.lower() == 'u') and (self.L != []) :  # evt.char = touche pressée
            self.L.pop()
            self.draw_polygon()

    def button_callback(self):      # reset
        self.L = []
        self.canvas.delete(ALL)     # ALL : tous les objets dans le canvas

    def draw_polygon(self):
        self.canvas.delete(ALL)     # effacement du canvas
        if len(self.L) == 0: return
        if len(self.L) == 1:
            [(x,y)] = self.L
            self.canvas.create_oval(x,y,x,y)
        else :
            Lpoints = [coord for pt in self.L for coord in pt]   # aplatissement
            self.canvas.create_polygon(*Lpoints,outline='black',fill='')

if __name__ == '__main__':
    ROOT = My_canvas_events_app()   # puis remplissage de L à la souris
    ROOT.mainloop()                 # bloquante
    print('ROOT.L =',ROOT.L)
    print('Fini')

    from webbrowser import open as browse
    #browse('http://tkinter.fdex.eu/doc/event.html?highlight=event')
    #browse('http://effbot.org/tkinterbook/tkinter-events-and-bindings.htm#protocols')
    #browse('https://www.python-course.eu/tkinter_canvas.php')



