#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

'''
section_9_1_8.py
03/03/2020
'''

print('Quelques exemples de codes du §9.1.8')
print("(déplacement d'un objet à la souris dans un canvas)")
print()

from tkinter import *

# Pour commencer, regardez la gestion des évènements-souris 
# dans le fichier mouse_events.py !

# Ensuite une application bien pratique :

class Drag_in_canvas(Tk):
    '''Déplacement d'un objet à la souris dans un canvas.'''
    def __init__(self):
        Tk.__init__(self)
        self.title('Drag in canvas')
        # le canevas et l'objet qu'il contient
        self.canvas = Canvas(self,width=200,height=200)
        self.canvas.pack()
        self.xd = self.yd = xd = yd = 100        # position initiale du disque
        self.canvas.create_oval(xd-20,yd-20,xd+20,yd+20,fill='red')    # rayon = 20
        # les gestionnaires d'evenements souris
        self.canvas.bind('<ButtonPress-1>',self.press)
        self.canvas.bind('<B1-Motion>',self.motion)
        self.canvas.bind('<ButtonRelease-1>',self.release)
        self.button_down = False
        self.resizable(width=False,height=False)

    def press(self,evt):                   # clic !
        (x,y) = (evt.x,evt.y)              # position de la souris au moment du clic
        if (x-self.xd)**2 + (y-self.yd)**2 < 400:    # clic dans disque ?
            self.dx = self.xd - x          # position par-rapport au centre du disque
            self.dy = self.yd - y
            self.button_down = True        # bouton enfoncé

    def motion(self,evt):                 # la souris bouge
        if self.button_down:              # bouton enfoncé ? Sinon laisser faire...
            (x,y) = (evt.x,evt.y)         # position actuelle de la souris
            # mise à jour de la position du disque
            self.xd = x + self.dx
            self.yd = y + self.dy
            # mise à jour du rendu des objets du canvas
            self.redraw()

    def release(self,evt):
        self.button_down = False

    def redraw(self):                     # dessin de tous les objets du canvas
        self.canvas.delete(ALL)           # on les supprime tous
        # puis on les ré-affiche à leur nouvelle position
        xd = self.xd ; yd = self.yd
        self.canvas.create_oval(xd-20,yd-20,xd+20,yd+20,fill='red')

if __name__ == "__main__":
    ROOT = Drag_in_canvas()
    ROOT.focus_force()
    ROOT.mainloop()                        # boucle d'évènements (bloquante)

    print('Position de la balle :',(ROOT.xd, ROOT.yd))
    print('Fini')

    from webbrowser import open as browse
    #browse('http://tkinter.fdex.eu/doc/event.html')
    #browse('http://tkinter.fdex.eu/doc/caw.html#Canvas.tag_lower')
    #browse('https://www.andrew.cmu.edu/course/15-112-n12/applications/ln/canvas/canvas.html')
    #browse('http://ateliers.mse.free.fr/tkinter/tkinter-ref5.pdf')

