#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
section_9_2.py
03/03/2020 
"""

print('Quelques exemples de codes du §9.2')
print('(programmer avec pyglet)')
print()

try:
    import pyglet
except:
    raise ModuleNotFoundError('Installez pyglet !')

class My_app(pyglet.window.Window):
    def __init__(self,width=100,height=400,grav=-0.5,frot=0.95) :
        pyglet.window.Window.__init__(self,width,height)        # vsync = True par défaut
        self.img = pyglet.resource.image('balle.png')           # texture de l'image de la balle
        self.r = self.img.height / 2                            # rayon de la balle
        self.img.anchor_x = self.r                              # repérage de la balle au centre
        self.img.anchor_y = self.r
        self.x = width / 2 ; self.y = 3/4 * height
        self.dy = 0                                             # vitesse verticale initiale
        self.grav = grav ; self.frot = frot                     # les constantes physiques
        pyglet.clock.schedule_interval(self.update,1/100)       # une horloge à 100 Hz ?
        self.fps_display = pyglet.clock.ClockDisplay()          # afficheur du framerate

    def on_draw(self):
        self.clear()                           # avec double buffer et vsync == True
        self.img.blit(self.x,self.y)           # fonction pyglet.image.Texture.blit
        self.fps_display.draw()                # affichage du framerate

    def update(self,dt):                       # le callback de l'horloge
        if (abs(self.y - self.r) < 1) and (abs(self.dy) < 2) :  # quasiment au repos ?
            pyglet.clock.unschedule(self.update)    # on coupe l'horloge
            print('La balle est en x={}, y={} avec dy={}'.format(w.x,w.y,w.dy))
            return
        ys = self.y + self.dy                  # j'essaye d'aller à cette position
        if ys < self.r:                        # collision avec le sol ?
            self.y = self.r                    # oui: p'tit truquage vidéo
            self.dy -= self.grav
            self.dy *= -self.frot
        else:
            self.y = ys                        # non: on y va
            self.dy += self.grav               # et on accélère

if __name__ == '__main__':
    w = My_app(400,400)                        # instanciation de la fenêtre graphique
    pyglet.app.run()                           # équivalent du mainloop() de tkinter
    print('Fini')

    # COMPLEMENTS EN LIGNE
    from webbrowser import open as browse
    #browse('http://www.poketcode.com/en/pyglet/index.html')     # code snippets...
    #browse('https://media.readthedocs.org/pdf/pyglet/latest/pyglet.pdf')
    #browse('https://bitbucket.org/pyglet/pyglet/wiki/Home')

