#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_json.py (11.122)
Passage de Python à JSON et inversement.
"""

import json

# --------- Conversion d'un objet JSON en objet Python et inversement --------
print('Conversion entre données JSON et Python')
print()
# J'ai reçu par un serveur une donnée JSON en syntaxe Javascript : une chaîne
# Unicode contenant un dictionnaire Javascript.
json_data = '{"Nom":"Hector", "Age":19, "Notes":[12,8,10,14], "Présent":true}'
print('json_data ==',repr(json_data))
print('json_data est de type',type(json_data))
print()
# Je la convertis en un objet Python :
python_data = json.loads(json_data)
print('python_data ==',python_data)
print('python_data est de type',type(python_data))
print()

# Inversement, l'objet Python peut être traduit en une chaîne JSON
json_data1 = json.dumps(python_data)
print('json_data1 ==',json_data1)
print('json_data1 est de type',type(json_data1))
print('\n---------------------------------------------\n')

# ---------- Application aux cours des crypto-monnaies ------------
# avec l'API du site ALPHAVANTAGE (https://www.alphavantage.co)

import requests

MY_API_KEY = "?????????????"            # demandez la vôtre ! Gratuit.
# je vais sur le marché des devises (CURRENCY_EXCHANGE_RATE) pour connaître le
# cours du Bitcoin-Cash (BCH) en euros (EUR) :
url = 'https://www.alphavantage.co/query?apikey={}&function={}&from_currency={}&to_currency={}'
url = url.format(MY_API_KEY,'CURRENCY_EXCHANGE_RATE','BCH','EUR')     # requête concrète

print('Connexion à Alpha Vantage pour le cours du Bitcoin-Cash')
reponse = requests.get(url)
print('reponse =',reponse)              # la réponse a été fournie (200 OK ?)
print()

# la réponse commence par un en-tête retourné sous forme d'un dictionnaire Python
print('reponse.headers :')
print(reponse.headers)
print()
format_rep = reponse.headers['Content-Type']
print('La réponse est une chaîne au format :',format_rep)
print()

# et continue par des données au format JSON
contenu_js = reponse.text              # une string contenant du Javascript
print(repr(contenu_js))
print()
contenu = reponse.json()               # et sa traduction en dictionnaire Python
print('soit, en Python, un dictionnaire :\n')
print(contenu)
print()

data = contenu['Realtime Currency Exchange Rate']      # un dictionnaire
# et son exploitation :
print('Arpentage du dictionnaire :\n')
COURS = None
for k in data:
    if k[0] in '245':
        if k[0] == '5': COURS = float(data[k])
        print(k[3:],':',data[k])
print()
print('Bref, 1 Bitcoin-Cash = {:.2f} Euros...'.format(COURS))

# COMPLEMENTS EN LIGNE
from webbrowser import open as browse
#browse('https://realpython.com/python-json/')
#browse('https://www.json.org')
#browse('https://towardsdatascience.com/getting-started-with-apis-in-python-to-gather-data-1185796b1ec3')
#browse('https://coinmarketcap.com')
#browse('https://bitcointalk.org/index.php?topic=375643.0')   # <-- hodling !
