#!/usr/bin/env python3
# -*- coding: utf-8 -*-

######################################################################
### PYTHON. APPRENTISSAGE ACTIF (JP. ROY, EDITIONS ELLIPSES, 2020) ###
######################################################################

"""
exo_valeur.py (11.7)
Mécanisme d'évaluation d'un appel de fonction.
Tous les arguments sont évalués, de gauche à droite,
avant que le corps de la fonction ne le soit.
"""

def foo(x,y,z):     # une fonction qui ne fait (presque) qu'évaluer ses arguments !
    print('foo')    # le corps de la fonction (ici une seule expression)

# dans quel ordre seront-ils évalués ? De gauche à droite : dans l'expression
# foo(print(1),print(2),print(3)), les arguments sont tous évalués à None, mais
# leur "effet" (un affichage) montre dans quel ordre ils ont été évalués.
foo(print(1),print(2),print(3))
print()

# De plus TOUS les arguments d'une fonction seront évalués, même si leur évaluation
# ne sert à rien.

def foo(x,y):       # y sera-t-il calculé alors qu'il ne sert à rien ?
    return x

# essayez d'évaluer foo(2,1/0) à la console : une erreur se produira.
    
# ----- COMPLEMENT OPTIONNEL -----
# Pour montrer qu'il y a bien une erreur sans bloquer l'évaluation de ce fichier
# sur erreur, j'utilise un "try...except..." pour intercepter l'erreur (§5.9) :
    
try:                     # j'essaye de faire ce calcul,
    print(foo(2,1/0))
except:                  # sauf que s'il rencontre une erreur (une "exception") :
    print("Il s'est bien produit une erreur !")

# Cette double stratégie d'évaluation des arguments ("tous, et de gauche à droite")
# est courante dans la plupart des langages de programmation, mais ce n'est pas la
# seule. Certains langages plus expérimentaux (comme Haskell par exemple)
# exploitent une stratégie "paresseuse" d'évaluation (lazy programming). L'idéal
# ne consisterait-il pas à ne calculer que ce qui est strictement nécessaire ?...

from webbrowser import open as browse
browse("https://fr.wikipedia.org/wiki/Stratégie_d'évaluation_(informatique)")

